/**
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


/**
 * AppletManager.java
 *
 * Created on 11 aot 2005, 10:41
 * Cette classe permet de grer les donnes d'une applet pour les restituer dans une autre.
 * Sauvegarde d'abord les calculs ou foncions nomms z1, z2, ..., z10 (s'ils existent)
 * en sauvegardant la chane de calcul qui les dfinit et la chaine reprsentant la
 * variable formelle (vide dans le cas d'un calcul).
 * Elle sauvegarde aussi les calculs nomms res1, res2, ..., res10.
 * Pour cela chaque applet MathGraph32 poss?dera un paramtre nomm Action du type String.
 * Si celui-ci contient "Sauvegarde", lors du positionnement de la figure, les valeurs
 * prcdemment cites seront enregistres dans le tableau valeurs et s'il contient
 * "Restitution", elles seront restitues aux variables var1, var2, var3, ..., var10.
 */

package Applet;

import objets.*;
import types.*;

public class AppletManager extends Object
{
	static String[] chaineZ = new String[20];
  static String[] varForZ = new String[20];
	static double[] doubleRes = new double[20];
  static int nombreZ; // Le nombre de calculs ou fonctions stock?s
  static int nombreRes; // Le nombre de rsultats numriques stock?s

	// Ajouter une applet ? la liste
	public void sauveValeurs(AppletMathGraph32 applet)
	{
    nombreZ = 0;
    nombreRes = 0;
    for (int i = 1; i <= 20; i++) {
      CCalcul pt = applet.listePr.pointeurCalculOuFonction("z"+Integer.toString(i),-1);
      if (pt != null) {
        nombreZ++;
        chaineZ[i-1] = pt.chaineCalcul;
        if (pt.getNatureCalcul() == NatureCalcul.NFonction) varForZ[i-1] = ((CFonc)pt).chaineVariable;
        else varForZ[i-1] ="";
      }
    }
    for (int i = 1; i <= 20; i++) {
      CCalcul pt = applet.listePr.pointeurCalculOuFonction("res"+Integer.toString(i),-1);
      if (pt != null) {
        if (pt.getNatureCalcul() == NatureCalcul.NCalculReel) {
          nombreRes++;
          doubleRes[i-1] = pt.resultat;
        }
      }
    }
	}
	// Supprimer une applet de la liste
	public void restitueValeurs(AppletMathGraph32 applet)
	{
    CCalcul ptc;
    Int inderr = new Int();
    CListeObjets liste = applet.listePr;
    for (int i = 1; (i <= 20) && (i<=nombreZ); i++) {
      ptc = liste.pointeurCalculOuFonction("z"+Integer.toString(i), -1);
      if (ptc != null) {
      	String[] tabvalf = new String[1];
      	tabvalf[0] = varForZ[i-1];
        if (CCalculBase.verifieSyntaxe(liste, chaineZ[i-1], inderr, liste.indexOf(ptc)-1,tabvalf)){
              applet.donneValeurA("z"+Integer.toString(i), chaineZ[i-1], varForZ[i-1]);
        }
      }
    }
	  for (int i = 1; (i <= 20) && (i<= nombreRes); i++) {
      ptc = liste.pointeurCalculOuFonction("res"+Integer.toString(i), -1);
      if (ptc != null) {
        if (ptc.getNatureCalcul() == NatureCalcul.NCalculReel) {
          applet.donneValeurA("res"+Integer.toString(i), Double.toString(doubleRes[i-1]), "");          
        }
      }
    }
  }
}
