/**
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package Applet;

/**
 *
 * @author Yves
 */
import java.io.IOException;
import objets.*;
import types.NatureObjet;
/**
 * Classe servant  grer les annulations refaire sur la figure
 * @author Yves
 */
public class GestionnaireEdition {
  static int nombreMaxiAnnulations = 50; // Le nombre maxi d'annulations autorises
  // Tableau qui recevra les sauvegardes de la figure
  // ByteArrayOutputStream[] sauvegarde = new ByteArrayOutputStream[nombreMaxiAnnulations];
  CListeObjets[] sauvegarde = new CListeObjets[nombreMaxiAnnulations];
  // Tableau qui recevra des chaines indiquant quel est le type d'action ayant
  // men  la sauvegarde d'indice l'ndice dans le tableau
  String natureSauvegarde[] = new String[nombreMaxiAnnulations];  // Recevra une chaine disant quel est le type d'action
                              // qui a men  la sauvegarde suivant son indice
  AppletMathGraph32 applet;      // L'applet sur laquelle agit le gestionnaire
  int indiceDerniereSauvegarde;
	int indiceFigureEnCours;      // Indice de la figure en cours dans le tableau de sauvegardes
  

  /**
   * Constructeur
   * @param documentInit
   * le document que gre le gestionnaire
   */
  public GestionnaireEdition(AppletMathGraph32 appletInit) {
    applet = appletInit;
  }
  /**
   * Sauvegarde la figure dans le fichier mmoire d'indice 0
   */
  public void initialise() throws IOException {
    // sauvegarde[0] = new ByteArrayOutputStream();
  	sauvegarde[0] = new CListeObjets(applet.listePr);
  	/*
    MathGraphDataOutputStream oups = new MathGraphDataOutputStream(sauvegarde[0]);
    cadre.listePr.write(oups);
    oups.close();
    */
  	applet.listePr.setCopy(sauvegarde[0]);
    indiceFigureEnCours = 0;
    indiceDerniereSauvegarde = 0;
  }
  /**
   * Sauvegarde de l'tat actuel de la figure
   */
  public void enregistreFigureEnCours(String nature) {
  	applet.document.setDirty(true);
    if (indiceFigureEnCours < nombreMaxiAnnulations - 1)
    {
      indiceFigureEnCours ++;
      natureSauvegarde[indiceFigureEnCours] = nature;
      // sauvegarde[indiceFigureEnCours] = new ByteArrayOutputStream(1000); // Modifi version 4.4 pour acclrer le transfert
      sauvegarde[indiceFigureEnCours] = new CListeObjets();
      applet.listePr.setCopy(sauvegarde[indiceFigureEnCours]);
      /*
      MathGraphDataOutputStream oups = new MathGraphDataOutputStream(sauvegarde[indiceFigureEnCours]);
      // On enregistre la liste d'objets principale dans l'archive
      cadre.listePr.write(oups);
      oups.close();
      */
      indiceDerniereSauvegarde = indiceFigureEnCours;
      // Il faut mettre  jour les liste maintenues de faon internes par les macros
      // quand la figure a t modifie
      applet.listePr.etablitListesInternesMacros();
      
    }
    else // Il faut tout dcaler et on perd alors la premire sauvegarde
    {
      for (int i = 1; i < nombreMaxiAnnulations; i ++)
      {
        natureSauvegarde[i - 1] = natureSauvegarde[i];
        sauvegarde[i - 1] = sauvegarde[i];
      }
      natureSauvegarde[nombreMaxiAnnulations - 1] = nature;
      // sauvegarde[nombreMaxiAnnulations - 1] = new ByteArrayOutputStream();
      sauvegarde[nombreMaxiAnnulations - 1] = new CListeObjets();
      applet.listePr.setCopy(sauvegarde[nombreMaxiAnnulations - 1]);
      /*
      MathGraphDataOutputStream oups = new MathGraphDataOutputStream(sauvegarde[nombreMaxiAnnulations - 1]);
      // On enregistre la liste d'objets principale dans l'archive
      cadre.listePr.write(oups);
      oups.close();
      */
      // Il faut mettre  jour les liste maintenues de faon internes par les macros
      // cadre.listePr.etablitListesInternesMacros();
    }
		metAJourTipIconesAnnulerRefaire();
  }
  public boolean annulationPossible() {
    return (indiceFigureEnCours > 0);    
  }
  public boolean refairePossible() {
    return (indiceFigureEnCours < indiceDerniereSauvegarde);    
  }
  public void annuleAction() throws IOException {
  	applet.document.setDirty(true);
    indiceFigureEnCours --;
    // Version 4.7.0.3 Il faut dtruire les MtgFormulaEditor associs  des CEditeurFormule
    applet.retireComposants();

    // Version 4.5.2. Il faut dtruire les MtgFormulaEditor associs  des CEditeurFormule
    CListeObjets listePr = applet.listePr;
    java.util.ListIterator <CElementBase> li = listePr.listIterator();
    while (li.hasNext()) {
    	CElementBase elb = li.next();
    	if (elb.estDeNature(NatureObjet.NEditeurFormule)) applet.paneCenter.remove(((CEditeurFormule)elb).mtgFormulaEditor);
    }
    // Fin version 4.5.2
    applet.listePr.retireTout();
    applet.listePr = new CListeObjets();
    sauvegarde[indiceFigureEnCours].setCopy(applet.listePr);
    applet.listePr.setClone(sauvegarde[indiceFigureEnCours]);
    applet.document.listePrincipale = applet.listePr;
    applet.listePr.documentProprietaire = applet.document;
    /*
    cadre.listePr.read(inps);
    inps.close();
    */
    // Il faut mettre  jour les liste maintenues de faon internes par les macros
    applet.listePr.etablitListesInternesMacros();
    applet.listeClone = new CListeObjets();
    applet.listePr.setCopy(applet.listeClone);
    applet.annuleSolutionProposee();
    applet.redessine();
		metAJourTipIconesAnnulerRefaire();
  }
  
  public void refaitAction() throws IOException {
  	applet.document.setDirty(true);
    indiceFigureEnCours ++;
    // Version 4.7.0.3 Il faut dtruire les MtgFormulaEditor associs  des CEditeurFormule
    applet.retireComposants();
    /*
    ByteArrayInputStream ba = new ByteArrayInputStream
            (sauvegarde[indiceFigureEnCours].toByteArray());
    MathGraphDataInputStream inps = new MathGraphDataInputStream(ba);
    cadre.listePr = new CListeObjets();
    */
    applet.listePr.retireTout();
    applet.listePr = new CListeObjets();
    sauvegarde[indiceFigureEnCours].setCopy(applet.listePr);
    applet.listePr.setClone(sauvegarde[indiceFigureEnCours]);
    applet.document.listePrincipale = applet.listePr;
    applet.listePr.documentProprietaire = applet.document;
    /*
    cadre.listePr.read(inps);
    inps.close();
    */
    // Il faut mettre  jour les liste maintenues de faon internes par les macros
    applet.etablitListeCalculsAutorises();
    applet.etablitListeObjetsConstruits();
    // Il faut mettre  jour les liste maintenues de faon internes par les macros
    applet.listePr.etablitListesInternesMacros();
    applet.listeClone = new CListeObjets();
    applet.listePr.setCopy(applet.listeClone);
    applet.annuleSolutionProposee();
    applet.redessine();
		metAJourTipIconesAnnulerRefaire();
 }
  public String chaineNatureAnnulationEnCours() {
    return natureSauvegarde[indiceFigureEnCours];    
  }
  public String chaineNatureRefaireEnCours() {
    return natureSauvegarde[indiceFigureEnCours + 1];    
  }
  
  public void metAJourTipIconesAnnulerRefaire() {
  	String ch;
  	if (applet.isConstruction()) {
	    if (annulationPossible()) ch = AppletMathGraph32.getString("ch13") + " "  + chaineNatureAnnulationEnCours();
	    else ch = "";
	    applet.buttonAnnuler.setToolTipText(ch);
	    if (refairePossible()) ch = AppletMathGraph32.getString("ch14") + " "  + chaineNatureRefaireEnCours();
	    else ch = "";
	    applet.buttonRefaire.setToolTipText(ch);
  	}
  }
  
}
