/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package Applet;

/**
 *
 * @author Yves
 */
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;

import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

import objets.*;
/**
 * Classe servant  grer les annulations refaire sur la figure
 * @author Yves
 */
public class GestionnaireEdition {
  static int nombreMaxiAnnulations = 30; // Le nombre maxi d'annulations autorises
  // Tableau qui recevra les sauvegardes de la figure
  ByteArrayOutputStream[] sauvegarde = new ByteArrayOutputStream[nombreMaxiAnnulations];
  // Tableau qui recevra des chaines indiquant quel est le tye d'action ayant
  // men  la sauvegarde d'indice l'ndice dans le tableau
  String natureSauvegarde[] = new String[nombreMaxiAnnulations];  // Recevra une chaine disant quel est la type d'action
                              // qui a men  la sauvegarde suivant son indice
  AppletMathGraph32 applet;      // L'applet sur laquelle agit le gestionnaire
  int indiceDerniereSauvegarde;
	int indiceFigureEnCours;      // Indice de la figure en cours dans le tableau de sauvegardes
  

  /**
   * Constructeur
   * @param documentInit
   * le document que gre le gestionnaire
   */
  public GestionnaireEdition(AppletMathGraph32 appletInit) {
    applet = appletInit;
  }
  /**
   * Sauvegarde la figure dans le fichier mmoire d'indice 0
   */
  public void initialise() throws IOException {
    sauvegarde[0] = new ByteArrayOutputStream();
    MathGraphDataOutputStream oups = new MathGraphDataOutputStream(sauvegarde[0]);
    applet.listePr.write(oups);
    oups.close();
    indiceFigureEnCours = 0;
    indiceDerniereSauvegarde = 0;
  }
  /**
   * Sauvegarde de l'tat actuel de la figure
   */
  public void enregistreFigureEnCours(String nature) {
    try {
      if (indiceFigureEnCours < nombreMaxiAnnulations - 1)
      {
        indiceFigureEnCours ++;
        natureSauvegarde[indiceFigureEnCours] = nature;
        sauvegarde[indiceFigureEnCours] = new ByteArrayOutputStream();
        MathGraphDataOutputStream oups = new MathGraphDataOutputStream(sauvegarde[indiceFigureEnCours]);
        // On enregistre la liste d'objets principale dans l'archive
        applet.listePr.write(oups);
        oups.close();
        indiceDerniereSauvegarde = indiceFigureEnCours;
        // Il faut mettre  jour les liste maintenues de faon internes par les macros
        // quand la figure a t modifie
        applet.listePr.etablitListesInternesMacros();
        
      }
      else // Il faut tout dcaler et on perd alors la premire sauvegarde
      {
        for (int i = 1; i < nombreMaxiAnnulations; i ++)
        {
          natureSauvegarde[i - 1] = natureSauvegarde[i];
          sauvegarde[i - 1] = sauvegarde[i];
        }
        natureSauvegarde[nombreMaxiAnnulations - 1] = nature;
        sauvegarde[nombreMaxiAnnulations - 1] = new ByteArrayOutputStream();
        MathGraphDataOutputStream oups = new MathGraphDataOutputStream(sauvegarde[nombreMaxiAnnulations]);
        // On enregistre la liste d'objets principale dans l'archive
        applet.listePr.write(oups);
        oups.close();
        // Il faut mettre  jour les liste maintenues de faon internes par les macros
        applet.listePr.etablitListesInternesMacros();
      }
    }
    catch (IOException err) {}
  }
  public boolean annulationPossible() {
    return (indiceFigureEnCours > 0);    
  }
  public boolean refairePossible() {
    return (indiceFigureEnCours < indiceDerniereSauvegarde);    
  }
  public void annuleAction() throws IOException {
    indiceFigureEnCours --;
    ByteArrayInputStream ba = new ByteArrayInputStream
            (sauvegarde[indiceFigureEnCours].toByteArray());
    MathGraphDataInputStream inps = new MathGraphDataInputStream(ba);
    applet.listePr = new CListeObjets();
    applet.listePr.read(inps);
    inps.close();
    applet.etablitListeObjetsConstruits();
    // Il faut mettre  jour les liste maintenues de faon internes par les macros
    applet.listePr.etablitListesInternesMacros();
    applet.listeClone = new CListeObjets();
    applet.listePr.setCopy(applet.listeClone);
    applet.annuleSolutionProposee();
    applet.redessine();
  }
  public void refaitAction() throws IOException {
    indiceFigureEnCours ++;
    ByteArrayInputStream ba = new ByteArrayInputStream
            (sauvegarde[indiceFigureEnCours].toByteArray());
    MathGraphDataInputStream inps = new MathGraphDataInputStream(ba);
    applet.listePr = new CListeObjets();
    applet.listePr.read(inps);
    inps.close();
    applet.etablitListeObjetsConstruits();
    // Il faut mettre  jour les liste maintenues de faon internes par les macros
    applet.listePr.etablitListesInternesMacros();
    applet.listeClone = new CListeObjets();
    applet.listePr.setCopy(applet.listeClone);
    applet.annuleSolutionProposee();
    applet.redessine();
  }
  public String chaineNatureAnnulationEnCours() {
    return natureSauvegarde[indiceFigureEnCours];    
  }
  public String chaineNatureRefaireEnCours() {
    return natureSauvegarde[indiceFigureEnCours + 1];    
  }
}
