/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package Applet;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import javax.swing.JPanel;
import objets.CCommentaire;
import objets.CListeObjets;
import objets.CMacro;
import objets.CMacroSuiteMacros;
import objets.CMathGrafDoc;
import outils.OutilPointage;
import outils.OutilPointageCapt;

/**
 *
 * @author Yves
 */
@SuppressWarnings("serial")
public class MtgPaneFigure extends JPanel {
  private AppletMathGraph32 appletMere;
  // Pour le double-buffering
  private Image imageBuffer;
  public Graphics2D gbuffer;
  // Nouveau pour la version 1.8 : un DeviceContext pour les macros laissant une trace
  private Image imageTraces;
  public Graphics2D tbuffer;

  public MtgPaneFigure(AppletMathGraph32 appletMereInit) {
    super();
    appletMere = appletMereInit;
  }
  public void effacegBuffer() {
    effaceFenetre(gbuffer);
  }
  public void effacetBuffer() {
    effaceFenetre(tbuffer);
  }
  // Nouveau pour la version 1.8
  public synchronized void afficheToutDansgbuffer() {
    if (appletMere.imageFond != null) {
       gbuffer.drawImage(appletMere.imageFond, 0, 0, this);
    }
    appletMere.listePr.afficheTout(gbuffer, appletMere.dimf, true, appletMere.couleurFond, appletMere.document.transparencePourSurfaces);
  }
  
	public synchronized void afficheToutDansgbufferSaufElementsDe(CListeObjets listeExclue) {
		Image imageFond = appletMere.imageFond;
		if (imageFond != null) {
			gbuffer.drawImage(imageFond, 0, 0, this);
		}
		appletMere.listePr.afficheToutSaufElementsDe(gbuffer, appletMere.dimf, true,
				appletMere.couleurFond, appletMere.document.transparencePourSurfaces, listeExclue);
	}
	
  
  
  public synchronized void afficheToutDansgbufferSansImFond() {
    appletMere.listePr.afficheTout(gbuffer, appletMere.dimf, true, appletMere.couleurFond, appletMere.document.transparencePourSurfaces);
  }
  
  public synchronized final void effaceFenetre(Graphics2D gc) {
    gc.setColor(appletMere.couleurFond); // N?cessaire car peut ?tre appel? en dehors de paint
    gc.fillRect(0,0, getWidth(), getHeight());
  }
  // Nouveau pour version 1.8 / Transfre l'image contenue dans le tbuffer (traces)
  // dans le gbuffer
  public void transferetbufferversgbuffer() {
    gbuffer.drawImage(imageTraces, 0, 0, this);
  }

  /**
   * Affichage dans le buffer lors de l'historique
   */
  public void afficheToutDansgbufferPourHist() {
    effaceFenetre(gbuffer);
    if (appletMere.imageFond != null) {
       gbuffer.drawImage(appletMere.imageFond, 0, 0, this);
    }
    Color couleurFond = appletMere.couleurFond;
    float transparence = appletMere.document.transparencePourSurfaces;
    appletMere.listePr.afficheJusque(gbuffer, appletMere.dimf,appletMere.listeSauve.size()-1, false,
    		couleurFond, transparence);
    appletMere.listeConstruction.afficheJusque(gbuffer, appletMere.dimf,
            appletMere.historiqueDlg.indiceObjetEnCours, false, couleurFond, transparence);
  }
  
	/**
	 * Affichage dans le buffer lors de l'historique y compris les objets de la
	 * liste clignotante
	 */
	public void afficheToutDansgbufferPourHistSaufListeClig() {
		CMathGrafDoc doc = appletMere.document;
		appletMere.paneFigure.effacegBuffer();
		//  revoir
		Image imageFond = appletMere.document.imageFond;
		if (imageFond != null) {
			appletMere.paneFigure.gbuffer.drawImage(imageFond, 0, 0, this);
		}
    appletMere.listePr.afficheJusque(gbuffer, appletMere.dimf, appletMere.listeSauve.size()-1,
    		false, doc.couleurFond, doc.transparencePourSurfaces);
    appletMere.listeConstruction.afficheJusqueSaufElementsDe(gbuffer, appletMere.dimf, appletMere.historiqueDlg.indiceObjetEnCours,
    		appletMere.listeClignotante, false, doc.couleurFond, doc.transparencePourSurfaces);
	}
  
  
  // Nouveau pour version 1.8
  // Envoie lengthcontenu du gbuffer sur l'?cran sans passer par pain()
  public void dessinegbuffer(Graphics2D gc) {
    gc.drawImage(imageBuffer, 0, 0, this);
    
  }
	// Il faut redfinir la mthode update car par dfaut elle efface le contenu
	// de
	// la fentre avec la couleur de fond avant d'appeler paint(), ce qui provoque
	// un effet de flash
	@Override
	public void update(Graphics graphics) {
		paint(graphics);
	}
  
  @Override
  public void paint(Graphics graphics) {
   
    if (appletMere.chargementEnCours) return;
    // Ajout version 2.0
    OutilPointage outilPointage = appletMere.outilPointageActif;
		if (outilPointage != null) {
			if (outilPointage.aRedessinerDansPaint)	outilPointage.actionDansPaint(appletMere);
		}
    Graphics2D g2D = (Graphics2D) graphics;
    setBackground(appletMere.couleurFond);
    Color couleurFond = appletMere.couleurFond;
    float transparence = appletMere.document.transparencePourSurfaces;
    CListeObjets listeObjetsVisuels = appletMere.listeObjetsVisuels;
    CListeObjets listePr = appletMere.listePr;
    CListeObjets listeSauve = appletMere.listeSauve;
    OutilPointage outilPointageActif = appletMere.outilPointageActif;
    OutilPointageCapt outilPointageCapture = appletMere.outilPointageCapture;
    CMacro macroAnimation = appletMere.macroAnimation;
    CMacro macroEnCours = appletMere.macroEnCours;
    CCommentaire commentaireDesignation = appletMere.commentaireDesignation;
    if (appletMere.premierAffichage) {
      // Il faut donner  la liste des objets servant  la cration visuelle d'objets
      // la mme unit d'angle que celle de la liste principale
      listeObjetsVisuels.uniteAngle = listePr.uniteAngle;
      // Je n'ai trouv que cet endroit pour que l'applet ait le focus clavier
      // requestFocus();
      listePr.positionne(false, appletMere.dimf);
      listeSauve.setClone(listePr);
      // Si on vient de charger une nouvelle figure, inutile de recr?er
      // les buffers;
      if (appletMere.adresseFigure == null) {   
        imageBuffer = createImage(getWidth(), getHeight());
        gbuffer = (Graphics2D) imageBuffer.getGraphics();
        effaceFenetre(gbuffer);
        imageTraces = createImage(getWidth(), getHeight());
        tbuffer = (Graphics2D) imageTraces.getGraphics();
        effaceFenetre(tbuffer);
      }
      // Bug corrig pour la version 2.5.4
      // Si l'applet est un exercice alatoire il faut recalculer alatoirement la figure
      appletMere.infRand = true;
      appletMere.positionne();
      appletMere.infRand = false;
      if (macroAnimation != null) {
        macroAnimation.actionAvantExecution(appletMere);
        if (appletMere.animationTimer == null) {
          appletMere.animationTimer = new java.util.Timer();
          appletMere.animationTimer.schedule(appletMere.timerTaskAnimation, 0l, macroAnimation.frequenceAnimation());
        }
      }
    }
    // Fonctionnement en double buffering
    if (macroAnimation != null) {
      macroAnimation.actionDansPaint(appletMere);
    }
    if (outilPointageActif == outilPointageCapture) {
      // Si une macro est en cours d'ex?cution
      if (macroEnCours != null) {
        CMacro mac = macroEnCours.macroEnCours();   // Dans le cas o? la maco en cours est une
                                                    // CMacroSuiteMacros, mac pointe sur la macro
                                                    // de la liste en cours d'ex?cution
        if (mac.executionEnCours) {
          mac.actionDansPaint(appletMere);
          if ((mac.executionEnCours == false) && (mac.typeAnimation() == CMacro.sansAnimation)) {
            // termineAtion est ? true sauf dans lengthcas d'une CMacroSuiteMacro quand la macro en cours
            // n'est pas la derni?re
            mac.termineAction(appletMere);
						if (!(appletMere.macroEnCours instanceof CMacroSuiteMacros))
							appletMere.macroEnCours = null;
            
            // Modification version 3.0
            // if (appletMere.macroEnCours.macroEnCours() == appletMere.macroEnCours) {
            //  if (!appletMere.macroEnCours.executionEnCours) appletMere.macroEnCours = null;
            //}
            
            //if (!(macroEnCours instanceof CMacroSuiteMacros)) macroEnCours = null;

          }
          else {
            if (mac.dureePourAnimation() != 0) {
              if (System.currentTimeMillis() >= mac.timeFin) {
                mac.termineAction(appletMere);
                mac.executionEnCours = false;
                if (!(macroEnCours instanceof CMacroSuiteMacros))  macroEnCours = null;
              }
            }
          }
        }
        if (macroEnCours != null) {
          if (macroEnCours instanceof CMacroSuiteMacros) {
            if (!macroEnCours.macroEnCours().executionEnCours) {
              ((CMacroSuiteMacros) macroEnCours).passageMacroSuiv(appletMere);
              // passageMacroSuiv redonne ventuellement un ordre paint() suivant la nature de la macro suivante
              // passageMacroSuiv met executionEnCours  false si la dernire macro a t excute
              if (!macroEnCours.executionEnCours) {
                macroEnCours.termineAction(appletMere);
                appletMere.macroEnCours = null;
              }
            }
          }
        }
        dessinegbuffer(g2D);
      }
      else
      {
        // Si un point n'est pas captur, affichage classique
        if (appletMere.premierAffichage) afficheToutDansgbuffer();
        // afficheToutDansgbuffer();
        if (commentaireDesignation.chaineCommentaire.length() != 0) {
          commentaireDesignation.positionne(appletMere.infRand, appletMere.dimf);
          dessinegbuffer(g2D);
          commentaireDesignation.affiche(g2D, true, couleurFond, transparence);
        }
        else dessinegbuffer(g2D);
      } 
      appletMere.premierAffichage = false;   
    }
    else {
      if (appletMere.historiqueEnCours) {
  			if (appletMere.listeClignotante.size() != 0) {
  				if (!appletMere.outilActif.nbClignPair)	afficheToutDansgbufferPourHistSaufListeClig();
  				else {
  					afficheToutDansgbufferPourHist();
  					appletMere.listeClignotante.afficheTout(gbuffer, appletMere.dimf, true, couleurFond, appletMere.document.transparencePourSurfaces);
  				}
  			} else	afficheToutDansgbufferPourHist();
  			dessinegbuffer(g2D);
      }
      else {
        // Si on est en cration visuelle d'objets,
        if (appletMere.premierAffichage) afficheToutDansgbuffer();
        dessinegbuffer(g2D);
        listeObjetsVisuels.positionne(appletMere.infRand, appletMere.dimf);
        listeObjetsVisuels.afficheTout(g2D, appletMere.dimf, true, couleurFond, appletMere.document.transparencePourSurfaces);
        if (commentaireDesignation.chaineCommentaire.length() != 0) {
          commentaireDesignation.positionne(appletMere.infRand, appletMere.dimf);
          commentaireDesignation.affiche(g2D, true, couleurFond, transparence);        
        }
      }
    }
  }
}
