/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package dialogs;

import Applet.AppletMathGraph32;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SwingConstants;
import objets.CPointParAbscisse;

/**
 *
 * @author Yves
 */
@SuppressWarnings("serial")
public class AbscisseDlg extends MtgDlg implements ActionListener {

  private EditeurValeur editeurAbscisse;
  private JButton btnOK, btnCancel,btnListeVal;
  private CPointParAbscisse pointAssocie;
  
  /** Creates a new instance of RayonDlg */
  public AbscisseDlg(AppletMathGraph32 appletInit, CPointParAbscisse pointAssocieInit) {
    super(null, textes.Chaines.abscisseDlg1, true, appletInit);
    setResizable(false);
    pointAssocie = pointAssocieInit;
    JLabel label = new JLabel(textes.Chaines.abscisseDlg1, SwingConstants.LEFT);
    editeurAbscisse = new EditeurValeur(applet, pointAssocie.abscisse, pointAssocie);
    btnCancel = new JButton(textes.Chaines.btnCancel);
    btnOK = new JButton(textes.Chaines.btnOK);
    btnListeVal = new JButton(textes.Chaines.listeValeurs);
    
    JPanel pane = new JPanel();
    pane.setLayout(new GridBagLayout());
    JPanel paneBas = new JPanel(); // Pour contenir les boutons OK et Cancel
    paneBas.setLayout(new GridBagLayout());
    
    GridBagConstraints constraints = new GridBagConstraints();
    constraints.insets.bottom = 5;
    constraints.insets.top = 5;
    constraints.insets.left = 5;
    constraints.insets.right = 5;
    
    setConstraints(constraints, 0, 0, 1, 1, 40, 40, GridBagConstraints.NONE, GridBagConstraints.WEST);
    pane.add(label, constraints);
    
    setConstraints(constraints, 1, 0, 1, 1, 60, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
    constraints.insets.bottom = 0;
    pane.add(editeurAbscisse, constraints);
    constraints.insets.bottom = 5;
    
    setConstraints(constraints, 0, 1, 2, 1, 0, 30, GridBagConstraints.NONE, GridBagConstraints.EAST);
    pane.add(btnListeVal, constraints);
    

    setConstraints(constraints, 0, 0, 1, 1, 50, 0, GridBagConstraints.NONE, GridBagConstraints.EAST);
    paneBas.add(btnOK, constraints);

    setConstraints(constraints, 1, 0, 1, 1, 50, 0, GridBagConstraints.NONE, GridBagConstraints.CENTER);
    paneBas.add(btnCancel, constraints);
    
    setConstraints(constraints, 0, 2, 2, 1, 0, 20, GridBagConstraints.NONE, GridBagConstraints.CENTER);
    pane.add(paneBas, constraints);
    
    setContentPane(pane);
    
    btnOK.addActionListener(this);
    btnCancel.addActionListener(this);
    btnListeVal.addActionListener(this);
    getRootPane().setDefaultButton(btnOK);    
    pack();
  }
  public void actionPerformed(ActionEvent evt) {
    if (evt.getSource()== btnOK) {
      // Si la rponse est valide, on ferme la boite de dialogue sans la dtruire.
      // VrifieValidite se charge de changer l'angle de la rotation si la rponse est
      // correcte.
      if (editeurAbscisse.verifieValidite()) {
        
        setRetourOK(true);
        dispose();
      }
    }
    else {
      if (evt.getSource() == btnCancel) {
        dispose();
      }
      else {
        if (evt.getSource() == btnListeVal) {
          int indmax = applet.listeConstruction.size() - 1;
          ListeValeursTextFieldDlg dlg = new ListeValeursTextFieldDlg(applet, editeurAbscisse, indmax);
          dlg.setLocationRelativeTo(null); // Pour centrer la boite de dialogue sur l'cran
          dlg.setVisible(true);
        }
      }
    }
    // La variable retourOK a t initialie  false donc tous les autres cas n'on pas  tre traits
  }
 
}
