/*
 * EditeurValeur.java
 *
 * Created on 10 juillet 2006, 19:04
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package dialogs;

import javax.swing.*;

import Applet.AppletMathGraph32;

import objets.*;
import types.*;

/**
 *
 * @author Yves
 * Classe ancetre de tous les diteurs insrs dans une boite de dialogue et chargs
 * de modifier la valeur d'une valeur dynamique
 */
@SuppressWarnings("serial")
public class EditeurValeurDynamique extends JTextField {
  protected AppletMathGraph32 applet;
  private CValeurAssocieeAVariable val; // L'objet CValeurDynamique que ce JTextField doit modifier.
  private CElementBase objet; // L'objet qui contient val et qui doit tre modifi
  
  /** Creates a new instance of EditeurValeur */
  public EditeurValeurDynamique(AppletMathGraph32 appletInit, 
      CValeurAssocieeAVariable valInit, CElementBase objetInit) {
    super(30);
    applet = appletInit;
    val = valInit;
    objet = objetInit;
    setEditable(true); 
  }
  /* Vrification de la validit de la rponse contenue dans le champ d'dition
   * du JTextField
  */
  public final boolean verifieValidite() {
    double v;
    int indice;
    // Pour la version applet on ne doit pouvoir utiliser que des objets
    // crs par l'utilisateur
    CListeObjets liste = applet.listePr;
    String rep = (String) getText();
    if (rep.length() == 0) {
    	MtgDlg.dialogueAvertissement(textes.Chaines.ch97);
    	requestFocus();
    	return false;
    }
    // Dans le cas ou on cre un nouvel objet, celui-ci n'a pas encore t ajout
    //  la liste des objets de l'applet.
    int indobj = liste.indexOf(objet);
    if (indobj == -1) indice = liste.size() - 1;
    else indice = indobj - 1;

    Int inderr = new Int();
    // On vrifie d'abord la syntaxe de la rponse
    // La seule valeur qu'on a le droit d'utiliser est pi qui est toujours
    // le premier objet de la liste
    if (CCalculBase.verifieSyntaxe(liste, rep, inderr, indice, "")){
    
      CCalculBase calc = CCalculBase.creeCalculBase(rep ,liste, 0, rep.length()-1, "");
      try {
        v = calc.resultat(false);
      }
      catch (ErreurCalculException e) {
        MtgDlg.dialogueAvertissement(textes.Chaines.ch44);
        requestFocus();
        return false;
      }

      if (valeurAcceptee(v))  {
        val.donneCalcul(calc);
        return true;
      }
      else return false;
    }
    else {
      // On place le curseur  l'endroit de l'erreur de syntaxe
      select(inderr.getValue(), inderr.getValue());
      MtgDlg.dialogueAvertissement(textes.Chaines.ch5);
      requestFocus();
      return false;
    }
  }
  
  /**
   * Fonction charge de vrifier si la rponse, quand elle est correcte, est valide
   * pour le type de valeur attendu. Par exemple, le rayon d'un cercle doit tre non nul.
   * Renvoie true par dfaut et doit tre redfinie pour tous les descendants.
   *
  */
  public boolean valeurAcceptee(double v) {
    return true;
  }
}
