/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package dialogs;

import java.util.ListIterator;
import java.util.Vector;

import javax.swing.JList;
import javax.swing.ListSelectionModel;

import objets.CElementBase;
import objets.CListeObjets;
import objets.CRepere;
import types.NatureCalcul;

@SuppressWarnings("serial")
public class ListeReperes extends JList<String> {
  private CListeObjets liste; // La liste contenant les valeurs  afficher
  private int indiceMaxi; // l'indice maxi permis pour un objet  insrer dans la liste
  private Vector<CRepere> reperes = new Vector<CRepere> ();
  
  /** Constructeur */
	public ListeReperes(CListeObjets listeInit, int indiceMaxiInit) {
		super();
    setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    liste = listeInit;
    indiceMaxi = indiceMaxiInit;
    if (indiceMaxi == -1) indiceMaxi = liste.size() - 1;
    int i = 0;
    
    Vector<String> values = new Vector<String> ();
    // On ajoute les noms des objets de type repre non intermmiaires  la liste
    ListIterator<CElementBase> li = liste.listIterator();
    while (i <= indiceMaxi)
    {
      CElementBase elb = li.next();
      if ((elb.getNatureCalcul() == NatureCalcul.NRepere) && !elb.estElementIntermediaire()){
        values.add(((CRepere)elb).nom());
        reperes.add((CRepere)elb);
      }
      i++;
    }
    setListData(values);
    setVisibleRowCount(4);
    setSelectedIndex(0);
  }
	
	/**
	 * Renvoie un pointeur sur le repre choisi
	 * 
	 */
	public CRepere repereChoisi() {
		return reperes.get(getSelectedIndex());
	}
	
  public void setSel(CRepere rep) {
  	int ind = reperes.indexOf(rep);
  	setSelectedIndex(ind);
  }
	
}
