/*
 * CAppelFonctionInterne.java
 *
 * Created on 4 novembre 2006, 20:40
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objets;

import types.*;

/**
 *
 * @author Yves
 */
/* 
  Nouveaut pour la version 1.9.5
  Pour pouvoir implmenter le calcul d'une drive (ce qui implique
  la drive d'une compose) il faut crer un nouveau type d'objet
  descendant de CCalculBase qui maintient un objet de type CCalculBase
  L'un correspond  la formule de la fonction et l'autre  la formule de l'oprande
  C'est le destructeur de ce nouveau type d'objet qui se chargera
  de dtruire les deux objets de type CCAclculBase encapsuls
  Il est aussi ncessaire de pouvoir cloner un objet de type CCalculBase
  pour pouvoir recopier des noeuds entiers dans la calcul d'une drive.
  Ce type d'objet n'est pas srializ dans le flux car le calcul de drive
  est cr  chaque chargement de la figure
 */
public class CAppelFonctionInterne extends CCalculBase {

	private CCalculBase fonctionInterne;
	private CCalculBase operande;

  /** Creates a new instance of CAppelFonctionInterne */
  public CAppelFonctionInterne(CCalculBase fonctionInterneInit, CCalculBase operandeInit) {
    fonctionInterne = fonctionInterneInit;
    operande = operandeInit;
  }
 /// resultat sera redfinie pour tous les descendants pouvant ne pas exister
  public double resultat(boolean infoRandom) throws ErreurCalculException {
    return fonctionInterne.resultatFonction(infoRandom,operande.resultat(infoRandom));
  }
  
  public double resultatFonction(boolean infoRandom, double valeurparametre) throws ErreurCalculException {
    return fonctionInterne.resultatFonction(infoRandom,
      operande.resultatFonction(infoRandom, valeurparametre));
  }
  public CCalculBase getCopie() { 
    return new CAppelFonctionInterne(fonctionInterne.getCopie(), operande.getCopie());
  }
  public boolean dependDeVariable()
  {
    return operande.dependDeVariable();
  }
  // Il faut dfinir getClone car elle est abstract dans CCalcul
  // mais elle est inutile car ce type d'objet n'est pas enregistr dans un flux
  public CCalculBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    return null;
  }
  
  @Override
	public boolean estConstant() {
		return fonctionInterne.estConstant() && operande.estConstant();
	}
  
  
}
