/*
 * CCalculAncetre.java
 *
 * Created on 1 juillet 2004, 18:33
 */

/**
 *
 * @author  Yves
 * @version
 */
package objets;

import java.io.*;

import types.*;

import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

// Modification de la version 2.5 : cette classe n'est plus abstract car elle peut tre
// instancie lors des chargements de prototypes
public class CCalculAncetre extends CValeurDynamique {
  public String nomCalcul;
  
  /** Creates new CCalculAncetre */
  public CCalculAncetre() {
  }

  public CCalculAncetre(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit) {
    super(liste, impProtoInit, estElementFinalInit);
  }
  
  // Constructeur pour clonage
  public CCalculAncetre(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
    String nomCalculInit) {
    super(liste, impProtoInit, estElementFinalInit);
    // listeProprietaire = liste; Modifi version 2.5
    nomCalcul = new String(nomCalculInit);
  }
  
  @Override
  public String nom() {
    return nomCalcul;
  }
  
  @Override
  public void donneNom(String  nouveauNom) {
  	nomCalcul = nouveauNom;
  }
  
  double rendValeurFonction(boolean infoRandom, double parametre)
  throws ErreurCalculException {
    return rendValeur(infoRandom);
  }
  // Ajout pour la version 2.0
  // Appel pour les appels de fonctions. Le rsultat est renvoy dans zRes
  // Seuls les descendants sont appels
  void rendValeurFonctionComplexe(boolean infoRandom, Complexe parametre, Complexe zRes)
  throws ErreurCalculException {
  }
  
  /**
   * Ajout pour la version 3.0 : Renvoie true seulement si le calcul associ
   * est constant et ne fait pas appel  la fonction Rand()
   * @return
   */
  public boolean estConstant() {
  	return false;
  }
  
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    nomCalcul = inps.readCString();
  }
  /* Lecture depuis un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    nomCalcul = inps.readUTF();
  }
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    oups.writeUTF(nomCalcul);
  }  
}
