/*
 * CCercleOR.java
 *
 * Created on 7 juillet 2004, 14:55
 */

/**
 *
 * @author  Yves
 * @version
 */
package objets;

import java.io.*;

import java.awt.Color;
import types.*;
import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

public class CCercleOR extends CCercle {
  
  private CPointAncetre O;
  public CValeurAssocieeAVariable R; // public pour modification par un dialogue
  
  /** Creates new CCercleOR */
  public CCercleOR() {
  }
  
  // Constructeur pour clonage
  public CCercleOR(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
    Color couleurInit, boolean masqueInit, int styleInit,
    CPointAncetre OInit, CValeurAssocieeAVariable RInit) {
    super(liste, impProtoInit, estElementFinalInit, couleurInit, masqueInit, styleInit);
    O = OInit;
    R = RInit;
  }
  
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(O);
    int ind2 = listeSource.indexOf(impProto);
    CValeurAssocieeAVariable RClone = (CValeurAssocieeAVariable) R.getClone(listeSource, listeCible);
    CElementBase ptelb = new CCercleOR(listeCible, (CImplementationProto)(listeCible.get(ind2, CImplementationProto.class)),
      estElementFinal, couleur, masque, style, (CPointAncetre)(listeCible.get(ind1, CPointAncetre.class)), RClone);
    return ptelb;
  }
  
  @Override
  public String infoPourHistorique() {
    return textes.Chaines.chinfo12 + " " + R.chaineInfo();
  }

  @Override
  public void ajouteAntecedents(CListeObjets liste) {
    liste.add(O);
  } 
  
  @Override
  public boolean dependDe(CElementBase p) {
    return super.dependDe(p) || O.dependDe(p) || R.dependDe(p) || listeProprietaire.pointeurLongueurUnite.dependDe(p);
  }
  
  @Override
  public boolean dependDePourBoucle(CElementBase p) {
   return ((p == this) || O.dependDePourBoucle(p) || R.dependDePourBoucle(p))
    	|| listeProprietaire.pointeurLongueurUnite.dependDePourBoucle(p);
  }
  
  @Override
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
  	R.positionne(infoRandom, dimfen);
  	CLongueur plongUnite = listeProprietaire.pointeurLongueurUnite;
    existe = O.existe && R.existe() && plongUnite.existe;
    if (existe) {
      centre_x = O.x;
      centre_y = O.y;
      rayon = R.rendValeur(infoRandom)*listeProprietaire.pointeurLongueurUnite.rendLongueur();
      super.positionne(infoRandom, dimfen);
    }
  }
  
  /** Rajout pour la version 2.0 : permet de connatre si l'lment point par pt
   * est confondu avec l'lment en question ou trs proche.
   * Pour cette version applet, ne sera redfini que pour les objets que l'utilisateur
   * pourra effectivement crer en ligne.
   **/
  @Override
  public boolean confonduAvec(CElementBase p) {
    CCercleOR pt;
    if (p.getClass() == this.getClass()) {
      pt = (CCercleOR) p;
      return (O == pt.O) && R.confonduAvec(pt.R);
    } else return false;
  }
  @Override
  public void remplacePoint(CPointAncetre ancienPoint, CPointAncetre nouveauPoint) {
    if (O == ancienPoint) O = nouveauPoint;
  }

  @Override
  public boolean utiliseLongueurUnite() {
  	return true;
  }
  
  @Override
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    int ind1 = inps.readCInt();
    O = (CPointAncetre) (list.get(ind1,CPointAncetre.class));
    R = new CValeurAssocieeAVariable();
    R.chargeDepuisFlux(inps, list);
  }
  /* Enregistrement dans un flux java */  
  @Override
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    int ind1 = inps.readInt();
    O = (CPointAncetre) (list.get(ind1,CPointAncetre.class));
    R = new CValeurAssocieeAVariable();
    R.read(inps, list);
  }  
  /* Enregistrement dans un flux java */
  @Override
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    int ind1 = list.indexOf(O);
    oups.writeInt(ind1);
    R.write(oups, list);
  }
  
  @Override
  public boolean contientParDefinition(CPointAncetre po) {
  	if (O == po) return true;
  	if (po.estPointImage()) {
  		CPointImage ptim = (CPointImage) po;
  		if (ptim.transformation.natureTransformation() == CTransformation.rotation) {
  			CRotation rot = (CRotation) ptim.transformation;
  			return ptim.antecedent.appartientParDefinition(this) && (rot.centre == O);
  		}
  		else return false;
  	}
  	else return false;
  }
  
}
