/*
 * CDerivee.java
 * Classe cre pour la version 1.9.5
 * Created on 4 novembre 2006, 22:02
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objets;


import java.io.*;
import types.*;
import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

/**
 *
 * @author Yves
 */
public class CDerivee extends CFonc {
  public CFonc fonctionAssociee;
  
  /** Creates a new instance of CDerivee */
  public CDerivee() {
    chaineCalcul = "";
    chaineVariable = "";
    calcul = null;
  }
  
  /**
   * Constructeur
   */
  public CDerivee(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
      String nomInit, CFonc fonctionAssocieeInit) {
  	super(liste, impProtoInit, estElementFinalInit, nomInit, "", null, "");
  	fonctionAssociee = fonctionAssocieeInit;
  	creeCalcul();
  }
  
  /**
   * Constructeur pour clonage
   */
  public CDerivee(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
      String nomInit, CCalculBase calculInit, CFonc fonctionAssocieeInit) {
  	super(liste, impProtoInit, estElementFinalInit, nomInit, "", calculInit, "");
  	fonctionAssociee = fonctionAssocieeInit;
  }
  
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(impProto);        
    CCalculBase calculClone = calcul.getClone(listeSource, listeCible);
    int ind2 = listeSource.indexOf(fonctionAssociee);
    CElementBase ptelb = new CDerivee(listeCible, (CImplementationProto)(listeCible.get(ind1, CImplementationProto.class)),
      estElementFinal, nomCalcul, calculClone, (CFonc)(listeCible.get(ind2, CFonc.class)));
    return ptelb;    
  } 
  
  /**
   * Constructeur spcial dans le cas d'une implmentation de prototype car le calcul
   * de la drive doit tre refait
   */
  public final CDerivee getClonePourImplementationProto(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(impProto);        
    int ind2 = listeSource.indexOf(fonctionAssociee);
    CDerivee ptelb = new CDerivee(listeCible, (CImplementationProto)(listeCible.get(ind1)),
      estElementFinal, nomCalcul, null, (CFonc)(listeCible.get(ind2)));
    return ptelb;      	
  }

  @Override
  public long getNatureCalcul() {
  	return NatureCalcul.NDerivee;
  }
  
  
  public boolean dependDe(CElementBase p) {
    return super.dependDe(p) || fonctionAssociee.dependDe(p);
  }

  public boolean dependDePourBoucle(CElementBase p) {
    return (p == this) || fonctionAssociee.dependDePourBoucle(p);
  }
  
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    existe = fonctionAssociee.existe;
  }
  
  public void creeCalcul()
  {
    calcul = CCalculBase.creeDerivee(fonctionAssociee.calcul);
  }
  
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFluxSansCalcul(inps,list);
    int ind1 = inps.readCInt();
    fonctionAssociee = (CFonc) (list.get(ind1,CFonc.class));
    // Modification pour la version 2.5
    // creeCalcul();
    if (list.getClass() != CPrototype.class) creeCalcul();
  }
  /* Enregistrement dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.readSansCalcul(inps, list);
    int ind1 = inps.readInt();
    fonctionAssociee = (CFonc) (list.get(ind1,CFonc.class));
    if (list.getClass() != CPrototype.class) creeCalcul();
  }
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.writeSansCalcul(oups, list);
    int ind1 = list.indexOf(fonctionAssociee);
    oups.writeInt(ind1);
  }    
}
