/*
 * CInversion.java
 *
 * Created on 10 juillet 2004, 14:14
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

// Classe de transformation inversion. Contrairement aux autres
// transformations, elle ne pourra tre utilise que pour des images
// de points et pas de droites, cercles ou autres objets
// Comme elle est dfinie par son centre et son rapport, elle drive de
// la classe CHomothtie
import java.awt.geom.*;

import types.*;

public class CInversion extends CHomothetie {

  /** Creates new CInversion */
  public CInversion() {
  }
  
  // Constructeur pour clonage
  public CInversion(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
    CPointAncetre centreInit, CValeurAssocieeAVariable rapportInit) {
    super(liste, impProtoInit, estElementFinalInit, centreInit, rapportInit);
  }

  @Override
	public int natureTransformation() {
		return inversion;
	}
  
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(centre);
    int ind2 = listeSource.indexOf(impProto);        
    CValeurAssocieeAVariable rapportClone = (CValeurAssocieeAVariable) rapport.getClone(listeSource, listeCible);
    CElementBase ptelb = new CInversion(listeCible, (CImplementationProto)(listeCible.get(ind2, CImplementationProto.class)),
      estElementFinal, (CPointAncetre)(listeCible.get(ind1, CPointAncetre.class)), rapportClone);
    return ptelb;
  }
  
  String designationTransf() {
    return textes.Chaines.chinfo23;
  }  
  
  public boolean dependDe(CElementBase p) {
    boolean resultat = super.dependDe(p);
    if (listeProprietaire.pointeurLongueurUnite == null)
      return resultat;
    else return resultat || (listeProprietaire.pointeurLongueurUnite.dependDe(p));
  }

  public boolean dependDePourBoucle(CElementBase p) {
    boolean resultat = super.dependDe(p);
    if (listeProprietaire.pointeurLongueurUnite == null)
      return resultat;
    else return resultat || (listeProprietaire.pointeurLongueurUnite.dependDePourBoucle(p));
  }

  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    CLongueur pLongUnite;
    double longueurUnite;

    super.positionne(infoRandom, dimfen);
    // A noter : valeurRapport a t calcul dans Homothetie.positionne()
    pLongUnite = listeProprietaire.pointeurLongueurUnite;
    existe = existe && pLongUnite.existe;
    if (!existe) return;
    longueurUnite = pLongUnite.rendLongueur();
    if (longueurUnite == 0)
    {
      existe = false;
    }
  }

  public void transformePoint(double x, double y, Point2D.Double pointr) {
  // Le point image du point d'affixe z est le point d'affixe z'
  // dfini par z' - w = k(z - w)/|z - w|, mais le module de
  // z - w doit tre calcul relativement  la longueur unit
  // (w dsigant l'affixe du centre)
    CLongueur pLongUnite;
    double longueurUnite;

    pLongUnite = listeProprietaire.pointeurLongueurUnite;
    longueurUnite = pLongUnite.rendLongueur();

    VecteurDirecteur u = new VecteurDirecteur(centre.x, centre.y, x, y);;
    double longueur = u.norme()/longueurUnite;
    double d = longueur*longueur;
    pointr.x = centre.x + valeurRapport*u.x/d;
    pointr.y = centre.y + valeurRapport*u.y/d;
  }

 public  boolean pointAUneImage(CPointAncetre point) {
  	return (!point.egal(centre));
  }
  
  // Java : par rapport au C++, inutile de redfinir chargeDepuisFlux car tout objet a un pointeur
  // sur sa liste propritaire
  
    
}
