/*
 * CLieuDePoints.java
 *
 * Created on 14 juillet 2004, 12:05
 */

/**
 *
 * @author  Yves
 * @version
 */
package objets;

import java.io.*;
import java.awt.Color;

import types.*;

import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;
import glob.*;

public class CLieuDePoints extends CLieuDeBase {
  CPointLie pointLieGenerateur;// le point li gnrateur du lieu
  
  /** Creates new CLieuDePoints */
  public CLieuDePoints() {
  }
  
  // Constructeur pour clonage
  public CLieuDePoints(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
    Color couleurInit, boolean masqueInit, int styleInit, CPointAncetre pointATracerInit, InfoLieu infoLieuInit,
    CPointLie pointLieGenerateurInit) {
    super(liste, impProtoInit, estElementFinalInit, couleurInit, masqueInit, styleInit, pointATracerInit, infoLieuInit);
    pointLieGenerateur = pointLieGenerateurInit;
  }
  
  
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    InfoLieu infoLieuClone = new InfoLieu(infoLieu);
    
    int ind1 = listeSource.indexOf(pointATracer);
    int ind2 = listeSource.indexOf(pointLieGenerateur);
    int ind3 = listeSource.indexOf(impProto);
    CElementBase ptelb = new CLieuDePoints(listeCible, (CImplementationProto)(listeCible.get(ind3, CImplementationProto.class)),
      estElementFinal, couleur, masque, style, (CPointAncetre)(listeCible.get(ind1, CPointAncetre.class)),
      infoLieuClone, (CPointLie)(listeCible.get(ind2, CPointLie.class)));
    if (listeCible.getClass() != CPrototype.class) {
	   ((CLieuDePoints)ptelb).listeElementsAncetres.setImage(listeElementsAncetres, listeProprietaire,
	      ptelb.listeProprietaire);
    }
    return ptelb;
  }
  
  @Override
  public void metAJour() {
  	super.metAJour();
  	etablitListeElementsAncetres();
  }
  
  // Modification pour la version 2.0 : quand des points sont isols ou n'existent pas on met leur abscissesCoordonneesPoints
  // et leurs ordonneesCoordonneesPoints  intMax de faon  ce que la distance entre un point et cette position ne puisse
  // pas tre suffisamment petite pour tre considre comme proche.
  // Cette modification est ncessaire  cause de l'introduction du point li  un lieu de points par point li
  // On doit pouvoir mesurer la distance entre le pointeur souris et les positions du point gnrateur du lieu
  // et calculer l'abscisse correspondante
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    double abscisseMini,abscisseMaxi,abscisse,abscisseInitiale,pas;
    
    if (!pointLieGenerateur.existe) {
      existe = false;
      return;
    }
    abscisseMini = pointLieGenerateur.abscisseMinimale();
    abscisseMaxi = pointLieGenerateur.abscisseMaximale();
    if (abscisseMini == abscisseMaxi) {
      existe = false;
      return;
    } else {
      // On ordonne l'abscisse minimale et maximale
      if (abscisseMini > abscisseMaxi) {
        double w = abscisseMini;
        abscisseMini = abscisseMaxi;
        abscisseMaxi = w;
      }
    }
    abscisseInitiale = pointLieGenerateur.abscisse;
    // Modification pour la version 1.9.5
    int nbValeurs;
    if (pointLieGenerateur.lieALigneFermee()) nbValeurs = infoLieu.nombreDePoints;
    else nbValeurs = infoLieu.nombreDePoints - 1;
    
    
    pas = (abscisseMaxi-abscisseMini)/nbValeurs;
    abscisse = abscisseMini - pas;
    
    boolean ligneEnCours = false;
    int indiceLigneEnCours = -1;
    
    for (int i = 0; i < infoLieu.nombreDePoints; i++) {
      abscisse = abscisse + pas;
      pointLieGenerateur.donneAbscisse(abscisse);
      listeElementsAncetres.positionne(infoRandom, dimfen);
      if (!pointATracer.existe) {
      	abscissesCoordonneesPoints[i] = Integer.MAX_VALUE;
      	ordonneesCoordonneesPoints[i] = Integer.MAX_VALUE;
        if (ligneEnCours) {
          infoLignes[indiceLigneEnCours].nombrePoints =
            i - infoLignes[indiceLigneEnCours].indicePremierPoint;
          ligneEnCours = false;
        }
      } else {
        if (!(Kernel.testToile(pointATracer.x,pointATracer.y))) {
          if (ligneEnCours) {
            infoLignes[indiceLigneEnCours].nombrePoints =
              i - infoLignes[indiceLigneEnCours].indicePremierPoint;
            ligneEnCours = false;
          }
        }
        else {
          if (ligneEnCours) {
            if (infoLieu.gestionDiscontinuite) {
              if ((Math.abs(pointATracer.x - abscissesCoordonneesPoints[i-1]) > dimfen.longueurAbscisses)
              || (Math.abs(pointATracer.y - ordonneesCoordonneesPoints[i-1]) > dimfen.longueurOrdonnees)) {
                infoLignes[indiceLigneEnCours].nombrePoints =
                  i - infoLignes[indiceLigneEnCours].indicePremierPoint;
                ligneEnCours = false;
              }
              else {
                abscissesCoordonneesPoints[i] = (int) Math.round(pointATracer.x);
                ordonneesCoordonneesPoints[i] = (int) Math.round(pointATracer.y);
                infoLignes[indiceLigneEnCours].nombrePoints++;
              }
            }
            else {
              abscissesCoordonneesPoints[i] = (int) Math.round(pointATracer.x);
              ordonneesCoordonneesPoints[i] = (int) Math.round(pointATracer.y);
              infoLignes[indiceLigneEnCours].nombrePoints++;
            }
          }
          else {
            abscissesCoordonneesPoints[i] = (int) Math.round(pointATracer.x);
            ordonneesCoordonneesPoints[i] = (int) Math.round(pointATracer.y);
            indiceLigneEnCours++;
            ligneEnCours = true;
            infoLignes[indiceLigneEnCours].indicePremierPoint = i;
            infoLignes[indiceLigneEnCours].nombrePoints = 1;
          }
        }
      }
    } // for
    
    // On  remet le point anctre  sa position initiale
    pointLieGenerateur.donneAbscisse(abscisseInitiale);
    listeElementsAncetres.positionne(infoRandom, dimfen);
    nombreLignes = indiceLigneEnCours + 1;
    // Si le lieu n'est form d'aucune ligne ou s'il est form
    // de lignes avec un seul point, il n'existe pas
    if (nombreLignes == 0) {
      existe = false;
      return;
    }
    boolean auMoinsUneLigne = false;
    indicePremiereLigne = -1;
    nombreLignesDePlusieursPoints = 0;
    for (int j = 0; j <= indiceLigneEnCours; j++) {
      boolean ligneTrouvee = (infoLignes[j].nombrePoints >= 2);
      if (ligneTrouvee) {
        nombreLignesDePlusieursPoints++;
        if (!auMoinsUneLigne) indicePremiereLigne = j;
        auMoinsUneLigne = true;
      }
    }
    if (!auMoinsUneLigne) {
      existe = false;
      return;
    }
    // Si le lieu est dclar comme ferm, il n'existera que s'il
    // n'est form que d'une seule ligne avec au moins deux points
    
    if (infoLieu.fermeOuNon) {
      if (nombreLignes != 1) {
        existe = false;
        return;
      }
      // On rajoute un dernier point gal de mme coordonnes
      // que le premier et on augmente le nombre de points de la ligne
      int indicePointRajoute = infoLignes[indicePremiereLigne].indicePremierPoint+
        infoLignes[indicePremiereLigne].nombrePoints;
      abscissesCoordonneesPoints[indicePointRajoute] =
        abscissesCoordonneesPoints[infoLignes[indicePremiereLigne].indicePremierPoint];
      ordonneesCoordonneesPoints[indicePointRajoute] =
        ordonneesCoordonneesPoints[infoLignes[indicePremiereLigne].indicePremierPoint];
      infoLignes[indicePremiereLigne].nombrePoints++;
    }
    existe = true;
  }
  
  public boolean confonduAvec(CElementBase p) {
    CLieuDePoints pt;
    if (p.getClass() == this.getClass()) {
      pt = (CLieuDePoints) p;
      return (pointATracer == pt.pointATracer) && (pointLieGenerateur == pt.pointLieGenerateur);
    } else return false;
  }
  
  public boolean dependDePourCapture(CElementBase p) {
    // Un lieu de points n'a pas  tre redessin si on bouge le point
    // li qui l'a engendr}
    return ((p == this) || (pointATracer.dependDe(p) && (p != pointLieGenerateur)));
  }
  
  public void etablitListeElementsAncetres() {
    int indicePointATracer = listeProprietaire.indexOf(pointATracer);
    // Modification pour la version 2.5.
    // Certaines choses pas  faire pour le chargement d'un prototype
    listeElementsAncetres.retireTout();
    if (listeProprietaire.getClass() != CPrototype.class) {
      for (int i = 0; i <= indicePointATracer; i++) {
        CElementBase ptelb = (CElementBase)(listeProprietaire.get(i));
        if ((pointATracer.dependDe(ptelb)) && (ptelb.dependDe(pointLieGenerateur)))
          listeElementsAncetres.add(ptelb);
      }
    }	
  }
  
	/**
	 * Fonction renvoyant true si l'objet dpend des positions gnres pas les dplacements d'un point li
	 * A redfinir pour les lieux de points et lieux d'objets et macros utilisant les dplacements d'un point li
	 * @param pointlie
	 * @return
	 */
  @Override
	public boolean estGenereParPointLie(CPointLie pointlie) {
		return pointLieGenerateur == pointlie;
	}
  
    
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list,nVersion >= 2);
    int ind1 = inps.readCInt();
    pointLieGenerateur = (CPointLie) (list.get(ind1,CPointLie.class));
    // Il faut prparer la liste des lments dont dpend le point  tracer
    // Version 1.9.5 : modifi pour optimisation
    int indicePointATracer = list.indexOf(pointATracer);
    // Modification pour la version 2.5.
    // Certaines choses pas  faire pour le chargement d'un prototype
    if (list.getClass() != CPrototype.class) {
      for (int i = 0; i <= indicePointATracer; i++) {
        CElementBase ptelb = (CElementBase)(list.get(i));
        if ((pointATracer.dependDe(ptelb)) && (ptelb.dependDe(pointLieGenerateur)))
          listeElementsAncetres.add(ptelb);
      }
    }
    nVersion = numeroVersion(); // On remet tout  zro pour la version java
  }
    /* Lecture depuis dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    int ind1 = inps.readInt();
    pointLieGenerateur = (CPointLie) (list.get(ind1,CPointLie.class));
    // Il faut prparer la liste des lments dont dpend le point  tracer
    // Version 1.9.5 : modifi pour optimisation
    int indicePointATracer = list.indexOf(pointATracer);
    // Modification pour la version 2.5.
    // Certaines choses pas  faire pour le chargement d'un prototype
    if (list.getClass() != CPrototype.class) {
      for (int i = 0; i <= indicePointATracer; i++) {
        CElementBase ptelb = (CElementBase)(list.get(i));
        if ((pointATracer.dependDe(ptelb)) && (ptelb.dependDe(pointLieGenerateur)))
          listeElementsAncetres.add(ptelb);
      }
    }
  }
  
  /** Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    int ind1 = list.indexOf(pointLieGenerateur);
    oups.writeInt(ind1);
  }     
}
