/*
 * CLieuDiscretParVariable.java
 *
 * Created on 16 juillet 2004, 09:53
 */

/**
 *
 * @author  Yves
 * @version
 */
package objets;

import java.io.*;
import java.awt.Color;

import types.*;

import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;
import glob.*;


public class CLieuDiscretParVariable extends CLieuDiscretDeBase {
  CVariableBornee variableGeneratrice;
  
  /** Creates new CLieuDiscretParVariable */
  public CLieuDiscretParVariable() {
  }
  
  // Constructeur pour clonage
  public CLieuDiscretParVariable(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
    Color couleurInit, boolean masqueInit, CPointAncetre pointATracerInit, int nombreDePointsInit, int motifInit,
    CVariableBornee variableGeneratriceInit) {
    super(liste, impProtoInit, estElementFinalInit, couleurInit,
      masqueInit, pointATracerInit, nombreDePointsInit, motifInit);
    variableGeneratrice = variableGeneratriceInit;
  }
  
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(pointATracer);
    int ind2 = listeSource.indexOf(variableGeneratrice);
    int ind3 = listeSource.indexOf(impProto);
    CElementBase ptelb = new CLieuDiscretParVariable(listeCible, (CImplementationProto)(listeCible.get(ind3, CImplementationProto.class)),
      estElementFinal, couleur, masque, (CPointAncetre)(listeCible.get(ind1, CPointAncetre.class)),
      nombreDePoints, motif, (CVariableBornee)(listeCible.get(ind2, CVariableBornee.class)));
    if (listeCible.getClass() != CPrototype.class) {
	    ((CLieuDiscretParVariable) ptelb).listeElementsAncetres = new CListeObjets(listeCible.uniteAngle, listeCible.pointeurLongueurUnite);
	    listeElementsAncetres.setImage(((CLieuDiscretParVariable)ptelb).listeElementsAncetres, ptelb.listeProprietaire,
	      listeProprietaire);
    }
    return ptelb;
  }
  
  @Override
  public void metAJour() {
  	super.metAJour();
  	etablitListeElementsAncetres();
  }
  
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    double valeur, valeurMinimale, valeurMaximale, valeurInitiale, pas;
    
    if (! variableGeneratrice.existe) {
      existe = false;
      return;
    }
    
    valeurMinimale = variableGeneratrice.valeurMini;
    valeurMaximale = variableGeneratrice.valeurMaxi;
    valeurInitiale = variableGeneratrice.valeurActuelle;
    pas = (valeurMaximale-valeurMinimale)/(nombreDePoints-1);
    valeur = valeurMinimale - pas;
    indiceDernierPointTrace = -1;
    for (int i = 0; i < nombreDePoints; i++) {
      valeur = valeur + pas;
      variableGeneratrice.donneValeur(valeur);
      listeElementsAncetres.positionne(infoRandom, dimfen);
      if (pointATracer.existe) {
        if (Kernel.testToile(pointATracer.x,pointATracer.y)) {
          indiceDernierPointTrace++;
          abscissesCoordonneesPoints[indiceDernierPointTrace] = (int) Math.round(pointATracer.x);
          ordonneesCoordonneesPoints[indiceDernierPointTrace] = (int) Math.round(pointATracer.y);
        }
      }
    }
    
    // On redonne  la variable gnratrice sa valeur initiale
    variableGeneratrice.donneValeur(valeurInitiale);
    listeElementsAncetres.positionne(infoRandom, dimfen);
    if (indiceDernierPointTrace >= 0)
      existe = true;
    else existe = false;
  }
  
  public boolean confonduAvec(CElementBase p) {
    CLieuParVariable pt;
    if (p.getClass() == this.getClass()) {
      pt = (CLieuParVariable) p;
      return (pointATracer == pt.pointATracer) && (variableGeneratrice == pt.variableGeneratrice);
    } else return false;
  }
    
  public void etablitListeElementsAncetres() {
    int indicePointATracer = listeProprietaire.indexOf(pointATracer);
    // Modification pour la version 2.5.
    // Certaines choses pas  faire pour le chargement d'un prototype
    listeElementsAncetres.retireTout();
    if (listeProprietaire.getClass() != CPrototype.class) {
      for (int i = 0; i <= indicePointATracer; i++) {
        CElementBase ptelb = (CElementBase)(listeProprietaire.get(i));
        if ((pointATracer.dependDe(ptelb)) && (ptelb.dependDe(variableGeneratrice)))
          listeElementsAncetres.add(ptelb);
      }
    }	
  }

  
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    int ind1 = inps.readCInt();
    variableGeneratrice = (CVariableBornee) (list.get(ind1,CVariableBornee.class));
    // Il faut prparer la liste des lments dont dpend le point  tracer
    // Version 1.9.5 : modifi pour optimisation
    // Modification pour la version 2.5.
    // Certaines choses pas  faire pour le chargement d'un prototype
    if (list.getClass() != CPrototype.class) {
      int indicePointATracer = list.indexOf(pointATracer);
      for (int i = 0; i <= indicePointATracer; i++) {
        CElementBase ptelb = (CElementBase)(list.get(i));
        if ((pointATracer.dependDe(ptelb)) && (ptelb.dependDe(variableGeneratrice)))
          listeElementsAncetres.add(ptelb);
      }
    }
  }
  /* Lecture depuis dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    int ind1 = inps.readInt();
    variableGeneratrice = (CVariableBornee) (list.get(ind1,CVariableBornee.class));
    // Il faut prparer la liste des lments dont dpend le point  tracer
    // Version 1.9.5 : modifi pour optimisation
    // Modification pour la version 2.5.
    // Certaines choses pas  faire pour le chargement d'un prototype
    if (list.getClass() != CPrototype.class) {
      int indicePointATracer = list.indexOf(pointATracer);
      for (int i = 0; i <= indicePointATracer; i++) {
        CElementBase ptelb = (CElementBase)(list.get(i));
        if ((pointATracer.dependDe(ptelb)) && (ptelb.dependDe(variableGeneratrice)))
          listeElementsAncetres.add(ptelb);
      }
    }
  }  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    int ind1 = list.indexOf(variableGeneratrice);
    oups.writeInt(ind1);
  }     
}
