/*
 * CLieuObjetParPtLie.java
 *
 * Created on 30 septembre 2006, 17:05
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package objets;

import java.io.*;
import java.awt.Color;
import types.*;
import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

/**
 *
 * @author Yves
 */
public class CLieuObjetParPtLie extends CLieuObjetAncetre {
  // Numro de version de l'objet. 1 par dfaut.
  private CPointLie pointLieGenerateur; // Le point li dont les positions successives gnreront la trace de l'objet
  
  /** Creates a new instance of CLieuObjetParPtLie */
  public CLieuObjetParPtLie() {
  }
  
  // Constructeur pour clonage
  public CLieuObjetParPtLie(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
    Color couleurInit, boolean masqueInit,
    CElementGraphique elementAssocieInit, CValeurAssocieeAVariable nombreTracesInit,
    CPointLie pointLieGenerateurInit) {
    super(liste, impProtoInit, estElementFinalInit, couleurInit,
      masqueInit, elementAssocieInit,  nombreTracesInit);
    pointLieGenerateur = pointLieGenerateurInit;
  }
  
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(elementAssocie);
    int ind2 = listeSource.indexOf(pointLieGenerateur);
    int ind3 = listeSource.indexOf(impProto);
    CValeurAssocieeAVariable nombreTracesClone = (CValeurAssocieeAVariable) nombreTraces.getClone(listeSource, listeCible);
    
    CElementBase ptelb = new CLieuObjetParPtLie(listeCible, (CImplementationProto)(listeCible.get(ind3, CImplementationProto.class)),
      estElementFinal, couleur, masque, (CElementGraphique)(listeCible.get(ind1, CElementGraphique.class)), nombreTracesClone,
      	(CPointLie)(listeCible.get(ind2, CPointLie.class)));
    if (listeCible.getClass() != CPrototype.class) {
	    ((CLieuObjetParPtLie)ptelb).listeElementsAncetres.setImage(listeElementsAncetres, listeProprietaire,
	      ptelb.listeProprietaire);
      // Comme le nombre d'objets est dynamique on ne peut pas savoir au chargement combien il y en a.
      // On laisse la liste vide et cela sera mis  jour lorsque positionne() sera appel
	    // if (listeSource.getClass() != CPrototype.class) ((CLieuObjetParPtLie)ptelb).listeCopiesObjet.ajouteClonesDe(((CLieuObjetParPtLie)ptelb).elementAssocie,
		  //    listeCopiesObjet.size());
	    
    }
    return ptelb;
  }
      
  @Override
  public void metAJour() {
  	super.metAJour();
  	etablitListeElementsAncetres();
  	// Retir version 2.0 : Inutile
  	// listeCopiesObjet.retireTout();
    // listeCopiesObjet.ajouteClonesDe(elementAssocie, (int) nombreTraces.rendValeur(false));
    // donneCouleur(couleur); // Pour que les lments clons aient la couleur du lieu d'objets
  }
  
  public boolean dependDePourCapture(CElementBase p) {
    return (pointLieGenerateur != p) && (((p == this)
    || elementAssocie.dependDe(p)) || nombreTraces.dependDe(p));
  }
  
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    int nbValeurs;
    double abscisseMini,abscisseMaxi,abscisse,abscisseInitiale,pas;
    super.positionne(infoRandom, dimfen);
    existe = existe && pointLieGenerateur.existe && (nombreObjetsPourLieuObjet() <= nombreMaxiPourLieuObjet) ;
    if (!existe) return;
    double dnbt = Math.round(nombreTraces.rendValeur(false));
    existe = (dnbt>=2) && (dnbt<=nombreMaxiPourLieuObjet);
    if (!existe) return;
    int nbt = (int) dnbt;
    
    // Changement important de la version 2.5, le nombre de traces tant devenu dynamique
    if (nbt != listeCopiesObjet.size()) ajusteListeCopieObjets();    
    abscisseMini = pointLieGenerateur.abscisseMinimale();
    abscisseMaxi = pointLieGenerateur.abscisseMaximale();
    if (abscisseMini == abscisseMaxi) {
      existe = false;
      return;
    } else {
      if (abscisseMini > abscisseMaxi) {
        double w = abscisseMini;
        abscisseMini = abscisseMaxi;
        abscisseMaxi = w;
      }
    }
    // Pour tenir compte des points lis lis  des lieux ferms
    if (pointLieGenerateur.lieALigneFermee()) nbValeurs = nbt;
    else nbValeurs = nbt - 1;
    abscisseInitiale = pointLieGenerateur.abscisse;
    pas = (abscisseMaxi-abscisseMini)/nbValeurs;
    abscisse = abscisseMini - pas;
    
    existe = false;
    boolean elementAssocieMasque = elementAssocie.masque;
    elementAssocie.montre();
    for (int i = 0;i < nbt; i++) {
      abscisse = abscisse + pas;
      pointLieGenerateur.donneAbscisse(abscisse);
       listeElementsAncetres.positionne(infoRandom, dimfen);
      existe = existe || elementAssocie.existe;
      CElementGraphique ptelg = (CElementGraphique)listeCopiesObjet.get(i);
      ptelg.setClone(elementAssocie);
      // Au cas o l'objet gnrateur du lieu serait ferm
      // ptelg.montre();
    }
    elementAssocie.masque = elementAssocieMasque;
    pointLieGenerateur.donneAbscisse(abscisseInitiale);
    listeElementsAncetres.positionne(infoRandom, dimfen);
  }
  
  @Override
  public boolean confonduAvec(CElementBase p) {
    CLieuObjetParPtLie pt;
    if (p.getClass() == this.getClass()) {
      pt = (CLieuObjetParPtLie) p;
  		return (pointLieGenerateur == pt.pointLieGenerateur)
			&& (elementAssocie == pt.elementAssocie)
			&& nombreTraces.confonduAvec(pt.nombreTraces);    
		}
    else return false;
  }  
  
  
  public void etablitListeElementsAncetres() {
    int indicePointATracer = listeProprietaire.indexOf(elementAssocie);
    // Modification pour la version 2.5.
    // Certaines choses pas  faire pour le chargement d'un prototype
    listeElementsAncetres.retireTout();
    if (listeProprietaire.getClass() != CPrototype.class) {
      for (int i = 0; i <= indicePointATracer; i++) {
        CElementBase ptelb = (CElementBase)(listeProprietaire.get(i));
        if ((elementAssocie.dependDe(ptelb)) && (ptelb.dependDe(pointLieGenerateur)))
          listeElementsAncetres.add(ptelb);
      }
    }	
  }
  
	/**
	 * Fonction renvoyant true si l'objet dpend des positions gnres pas les dplacements d'un point li
	 * A redfinir pour les lieux de points et lieux d'objets et macros utilisant les dplacements d'un point li
	 * @param pointlie
	 * @return
	 */
  @Override
	public boolean estGenereParPointLie(CPointLie pointlie) {
		return pointLieGenerateur == pointlie;
	}
  
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    if (nVersion == 1) {
    	super.chargeDepuisFlux(inps, list);
    	nVersion = numeroVersion(); // On remet tout  zro pour la version java
    }
    else super.chargeDepuisFluxNew(inps, list);
    int ind1 = inps.readCInt();
    pointLieGenerateur = (CPointLie) (list.get(ind1,CPointLie.class));
    // Il faut prparer la liste des lments dont dpend l'objet  tracer
    // Version 1.9.5 : modifi pour optimisation
    // Modification pour la version 2.5.
    // Certaines choses pas  faire pour le chargement d'un prototype
    if (list.getClass() != CPrototype.class) {
      int indiceElementAssocie = list.indexOf(elementAssocie);
      for (int i = 0; i <= indiceElementAssocie; i++) {
        CElementBase ptelb = (CElementBase)(list.get(i));
        if ((elementAssocie.dependDe(ptelb)) && (ptelb.dependDe(pointLieGenerateur)))
          listeElementsAncetres.add(ptelb);
      }
    }
    nVersion = numeroVersion(); // On remet tout  zro pour la version java
  }
  /* Lecture depuis dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    int ind1 = inps.readInt();
    pointLieGenerateur = (CPointLie) (list.get(ind1,CPointLie.class));
    // Il faut prparer la liste des lments dont dpend le point  tracer
    // Version 1.9.5 : modifi pour optimisation
    // Modification pour la version 2.5.
    // Certaines choses pas  faire pour le chargement d'un prototype
    if (list.getClass() != CPrototype.class) {
      int indiceElementAssocie = list.indexOf(elementAssocie);
      for (int i = 0; i <= indiceElementAssocie; i++) {
        CElementBase ptelb = (CElementBase)(list.get(i));
        if ((elementAssocie.dependDe(ptelb)) && (ptelb.dependDe(pointLieGenerateur)))
          listeElementsAncetres.add(ptelb);
      }
    }
  }  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    int ind1 = list.indexOf(pointLieGenerateur);
    oups.writeInt(ind1);
  }
}