package objets;
/*
 * CLieuParVariable.java
 *
 * Created on 14 juillet 2004, 18:04
 */

/**
 *
 * @author  Yves
 * @version
 */
import java.io.*;
import java.awt.Color;

import types.DimensionFenetre;
import types.InfoLieu;

import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;
import glob.Kernel;

public class CLieuParVariable extends CLieuDeBase {
  CVariableBornee  variableGeneratrice;
  
  /** Creates new CLieuParVariable */
  public CLieuParVariable() {
  }
  
  // Constructeur pour clonage
  public CLieuParVariable(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
    Color couleurInit, boolean masqueInit, int styleInit,
    CPointAncetre pointATracerInit, InfoLieu infoLieuInit,
    CVariableBornee variableGeneratriceInit) {
    super(liste, impProtoInit, estElementFinalInit, couleurInit, masqueInit, styleInit, pointATracerInit, infoLieuInit);
    variableGeneratrice = variableGeneratriceInit;
  }
  
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    InfoLieu infoLieuClone = new InfoLieu(infoLieu);
    int ind1 = listeSource.indexOf(pointATracer);
    int ind2 = listeSource.indexOf(variableGeneratrice);
    int ind3 = listeSource.indexOf(impProto);
    CElementBase ptelb = new CLieuParVariable(listeCible, (CImplementationProto)(listeCible.get(ind3, CImplementationProto.class)),
      estElementFinal, couleur, masque, style, (CPointAncetre)(listeCible.get(ind1, CPointAncetre.class)),
      infoLieuClone, (CVariableBornee)(listeCible.get(ind2, CVariableBornee.class)));
    if (listeCible.getClass() != CPrototype.class) {
	    ((CLieuParVariable)ptelb).listeElementsAncetres.setImage(listeElementsAncetres, listeProprietaire,
	      ptelb.listeProprietaire);
    }
    return ptelb;
  }
  
  @Override
  public void metAJour() {
  	super.metAJour();
  	etablitListeElementsAncetres();
  }
  
  
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    double valeur, valeurMinimale, valeurMaximale, valeurInitiale, pas;
    
    if (! variableGeneratrice.existe) {
      existe = false;
      return;
    }
    
    valeurMinimale = variableGeneratrice.valeurMini;
    valeurMaximale = variableGeneratrice.valeurMaxi;
    valeurInitiale = variableGeneratrice.valeurActuelle;
    pas = (valeurMaximale-valeurMinimale)/(infoLieu.nombreDePoints-1);
    valeur = valeurMinimale - pas;
    boolean ligneEnCours = false;
    int indiceLigneEnCours = -1;
    for (int i = 0; i < infoLieu.nombreDePoints; i++) {
      valeur = valeur + pas;
      variableGeneratrice.donneValeur(valeur);
      listeElementsAncetres.positionne(infoRandom, dimfen);
      if (!pointATracer.existe) {
        if (ligneEnCours) {
          infoLignes[indiceLigneEnCours].nombrePoints =
            i - infoLignes[indiceLigneEnCours].indicePremierPoint;
          ligneEnCours = false;
        }
      } else {
        if (!(Kernel.testToile(pointATracer.x,pointATracer.y))) {
          if (ligneEnCours) {
            infoLignes[indiceLigneEnCours].nombrePoints =
              i - infoLignes[indiceLigneEnCours].indicePremierPoint;
            ligneEnCours = false;
          }
        }
        else {
          if (ligneEnCours) {
            if (infoLieu.gestionDiscontinuite) {
              if ((Math.abs(pointATracer.x - abscissesCoordonneesPoints[i-1]) > dimfen.longueurAbscisses)
              || (Math.abs(pointATracer.y - ordonneesCoordonneesPoints[i-1]) > dimfen.longueurOrdonnees)) {
                infoLignes[indiceLigneEnCours].nombrePoints =
                  i - infoLignes[indiceLigneEnCours].indicePremierPoint;
                ligneEnCours = false;
              }
              else {
                abscissesCoordonneesPoints[i] = (int) Math.round(pointATracer.x);
                ordonneesCoordonneesPoints[i] = (int) Math.round(pointATracer.y);
                infoLignes[indiceLigneEnCours].nombrePoints++;
              }
            }
            else {
              abscissesCoordonneesPoints[i] = (int) Math.round(pointATracer.x);
              ordonneesCoordonneesPoints[i] = (int) Math.round(pointATracer.y);
              infoLignes[indiceLigneEnCours].nombrePoints++;
            }
          }
          else {
            abscissesCoordonneesPoints[i] = (int) Math.round(pointATracer.x);
            ordonneesCoordonneesPoints[i] = (int) Math.round(pointATracer.y);
            indiceLigneEnCours++;
            ligneEnCours = true;
            infoLignes[indiceLigneEnCours].indicePremierPoint = i;
            infoLignes[indiceLigneEnCours].nombrePoints = 1;
          }
        }
      }
    }
    // On redonne  la variable gnratrice sa valeur initiale
    variableGeneratrice.donneValeur(valeurInitiale);
    listeElementsAncetres.positionne(infoRandom, dimfen);
    nombreLignes = indiceLigneEnCours + 1;
    // Si le lieu n'est form d'aucune ligne ou s'il est form
    // de lignes avec un seul point, il n'existe pas
    if (nombreLignes == 0) {
      existe = false;
      return;
    }
    boolean auMoinsUneLigne = false;
    indicePremiereLigne = -1;
    nombreLignesDePlusieursPoints = 0;
    for (int j = 0; j <= indiceLigneEnCours; j++) {
      boolean ligneTrouvee = (infoLignes[j].nombrePoints >= 2);
      if (ligneTrouvee) {
        nombreLignesDePlusieursPoints++;
        if (!auMoinsUneLigne) indicePremiereLigne = j;
        auMoinsUneLigne = true;
      }
    }
    if (!auMoinsUneLigne) {
      existe = false;
      return;
    }
    // Si le lieu est dclar comme ferm, il n'existera que s'il
    // n'est form que d'une seule ligne avec au moins deux points
    
    if (infoLieu.fermeOuNon) {
      if (nombreLignes != 1) {
        existe = false;
        return;
      }
      // On rajoute un dernier point gal de mme coordonnes
      // que le premier et on augmente le nombre de points de la ligne
      int indicePointRajoute = infoLignes[indicePremiereLigne].indicePremierPoint+
        infoLignes[indicePremiereLigne].nombrePoints;
      abscissesCoordonneesPoints[indicePointRajoute] =
        abscissesCoordonneesPoints[infoLignes[indicePremiereLigne].indicePremierPoint];
      ordonneesCoordonneesPoints[indicePointRajoute] =
        ordonneesCoordonneesPoints[infoLignes[indicePremiereLigne].indicePremierPoint];
      infoLignes[indicePremiereLigne].nombrePoints++;
    }
    existe = true;
  }  
  
  public boolean confonduAvec(CElementBase p) {
    CLieuParVariable pt;
    if (p.getClass() == this.getClass()) {
      pt = (CLieuParVariable) p;
      return (pointATracer == pt.pointATracer) && (variableGeneratrice == pt.variableGeneratrice);
    } else return false;
  }
  
  public void etablitListeElementsAncetres() {
    int indicePointATracer = listeProprietaire.indexOf(pointATracer);
    // Modification pour la version 2.5.
    // Certaines choses pas  faire pour le chargement d'un prototype
    listeElementsAncetres.retireTout();
    if (listeProprietaire.getClass() != CPrototype.class) {
      for (int i = 0; i <= indicePointATracer; i++) {
        CElementBase ptelb = (CElementBase)(listeProprietaire.get(i));
        if ((pointATracer.dependDe(ptelb)) && (ptelb.dependDe(variableGeneratrice)))
          listeElementsAncetres.add(ptelb);
      }
    }	
  }
    
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list,nVersion >= 2);  // modification version 2.5 gestion discontinuit des lieux
    int ind1 = inps.readCInt();
    variableGeneratrice = (CVariableBornee) (list.get(ind1,CVariableBornee.class));
    // Il faut prparer la liste des lments dont dpend le point  tracer
    // Modification pour la version 2.5.
    // Certaines choses pas  faire pour le chargement d'un prototype
    if (list.getClass() != CPrototype.class) {
      int indicePointATracer = list.indexOf(pointATracer);
      for (int i = 0; i <= indicePointATracer; i++) {
        CElementBase ptelb = (CElementBase)(list.get(i));
        // Modification apporte pour optimisation lors de la version 1.9.5
        //if (pointATracer.dependDe(ptelb))	listeElementsAncetres.add(ptelb);
        if ((pointATracer.dependDe(ptelb)) && (ptelb.dependDe(variableGeneratrice)))
          listeElementsAncetres.add(ptelb);
      }
    }
    nVersion = numeroVersion(); // On remet tout  zro pour la version java
  }
  /* Lecture depuis dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    int ind1 = inps.readInt();
    variableGeneratrice = (CVariableBornee) (list.get(ind1,CVariableBornee.class));
    // Il faut prparer la liste des lments dont dpend le point  tracer
    // Modification pour la version 2.5.
    // Certaines choses pas  faire pour le chargement d'un prototype
    if (list.getClass() != CPrototype.class) {
      int indicePointATracer = list.indexOf(pointATracer);
      for (int i = 0; i <= indicePointATracer; i++) {
        CElementBase ptelb = (CElementBase)(list.get(i));
        // Modification apporte pour optimisation lors de la version 1.9.5
        //if (pointATracer.dependDe(ptelb))	listeElementsAncetres.add(ptelb);
        if ((pointATracer.dependDe(ptelb)) && (ptelb.dependDe(variableGeneratrice)))
          listeElementsAncetres.add(ptelb);
      }
    }
  }  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    int ind1 = list.indexOf(variableGeneratrice);
    oups.writeInt(ind1);
  }
}
