/**
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import java.awt.*;

import Applet.AppletMathGraph32;
import Applet.MtgPaneFigure;

public class CMacroAffichantTout extends CMacro {

  /** Creates new CMacroAffichantTout */
  public CMacroAffichantTout() {
  }
  
  // Constructeur pour clonage
  public CMacroAffichantTout(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
      Color couleurInit, double x_nomInit, double y_nomInit, double dec_xInit, double dec_yInit, boolean masqueInit,
      CPointAncetre pointLieInit, int indiceTaillePoliceInit,
      boolean effacementFondInit, Color couleurFondInit, String intituleInit, String commentaireMacroInit,
    	int alignementHorizontalInit, int alignementVerticalInit) {
        super (liste, impProtoInit, estElementFinalInit, couleurInit, x_nomInit, y_nomInit,
          dec_xInit, dec_yInit, masqueInit, pointLieInit, indiceTaillePoliceInit,
          effacementFondInit, couleurFondInit, intituleInit, commentaireMacroInit,
          alignementHorizontalInit, alignementVerticalInit);
  }
        
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(pointLie);  
    int ind2 = listeSource.indexOf(impProto);        
    return new CMacroAffichantTout(listeCible, (CImplementationProto)(listeCible.get(ind2, CImplementationProto.class)),
      estElementFinal, couleur, x_nom, y_nom, dec_x, dec_y, masque,
      (CPointAncetre)listeCible.get(ind1, CPointAncetre.class), indiceTaillePolice,
      effacementFond, couleurFondAffichage, intitule, commentaireMacro, alignementHorizontal, alignementVertical);
  }

  @Override
  public void actionDansPaint(AppletMathGraph32 applet) {
  	MtgPaneFigure paneFigure = applet.paneFigure;
    DetruitTimersThread(applet);
    // On efface tout l'cran avant que paint se charge de rafficher la figure
    paneFigure.effaceFenetre(paneFigure.gbuffer);
    // applet.initialisetBuffer(); // Modification version 4.4.4
    applet.effacetBuffer();  // Ajout version 4.4.4
    applet.infRand= true;
    applet.listePr.positionne(applet.infRand, applet.dimf);
    applet.infRand = false;
    paneFigure.afficheToutDansgbuffer();       
    executionEnCours = false;
  }

  @Override
  public boolean executionPossible() {
    return true;
  }
  
}
