/*
 * CMacroApparition.java
 *
 * Created on 5 aot 2004, 18:49
 */

/**
 *
 * @author  Yves
 * @version
 */
package objets;

import java.io.*;
import java.awt.Color;
import Applet.AppletMathGraph32;
import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

public class CMacroApparition extends CMacroAvecListe {
  public boolean clicPourObjetSuivant;
  int indiceDernierObjetTraite; // sera incrment si clicPourObjetSuivant est true
  /** Creates new CMacroApparition */
  public CMacroApparition() {
  }
  
  // Constructeur pour clonage
  public CMacroApparition(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
    Color couleurInit, double x_nomInit, double y_nomInit, double dec_xInit, double dec_yInit, boolean masqueInit,
    CPointAncetre pointLieInit, int indiceTaillePoliceInit, int encadrementInit,
    boolean effacementFondInit, Color couleurFondInit, String intituleInit, String commentaireMacroInit,
    CSousListeObjets listeAssocieeInit, boolean clicPourObjetSuivantInit) {
    super(liste, impProtoInit, estElementFinalInit, couleurInit, x_nomInit, y_nomInit,
      dec_xInit, dec_yInit, masqueInit, pointLieInit, indiceTaillePoliceInit, encadrementInit,
      effacementFondInit, couleurFondInit, intituleInit, commentaireMacroInit, listeAssocieeInit);
    clicPourObjetSuivant = clicPourObjetSuivantInit;
  }
  
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(pointLie);
    int ind2 = listeSource.indexOf(impProto);
    CSousListeObjets listeAssocieeClone = new CSousListeObjets();
    listeAssocieeClone.setImage(listeAssociee, listeSource, listeCible);
    CElementBase ptelb = new CMacroApparition(listeCible, (CImplementationProto)(listeCible.get(ind2, CImplementationProto.class)),
      estElementFinal, couleur, x_nom, y_nom, dec_x, dec_y, masque,
      (CPointAncetre)listeCible.get(ind1, CPointAncetre.class), indiceTaillePolice, encadrement,
      effacementFond, couleurFondAffichage, intitule, commentaireMacro, listeAssocieeClone, clicPourObjetSuivant);
    return ptelb;
  }
  
  @Override
  public void actionAvantExecution(AppletMathGraph32 applet) { // par dfaut, met executionEnCours  true;
  	super.actionAvantExecution(applet);  // Met executioEnCours  true
    if (clicPourObjetSuivant) {
      indiceDernierObjetTraite = -1;
    }
  }
  
  /**
   * Version java . Pour la gestion des clics par l'outil d'excution de macro
   */
  @Override
  public void termineAction(AppletMathGraph32 applet) {
    super.termineAction(applet);
  	if ((clicPourObjetSuivant) && (indiceDernierObjetTraite != listeAssociee.size() - 1)) executionEnCours = true;
  	else executionEnCours = false;
  }

  
  @Override
  public void actionDansPaint(AppletMathGraph32 applet) {
    if (clicPourObjetSuivant) {
      indiceDernierObjetTraite ++;
      ((CElementGraphique) (listeAssociee.get(indiceDernierObjetTraite))).montre();
      executionEnCours = (indiceDernierObjetTraite != listeAssociee.size() - 1);
      if (executionEnCours) applet.indication(textes.Chaines.ch107);
      else applet.indication("");

    } else {
      listeAssociee.montreTout(true);
      executionEnCours = false;
    }
    applet.paneFigure.afficheToutDansgbuffer();
  }
  
  // Java :  revoir plus tard
    
  @Override
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    if (listeProprietaire.numeroVersion == 1) clicPourObjetSuivant = false;
    else clicPourObjetSuivant = inps.readBoolean();
  }
  /* Lecture depuis dans un flux java */  
  @Override
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    clicPourObjetSuivant = inps.readBoolean();
  }  
  /* Enregistrement dans un flux java */
  @Override
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    oups.writeBoolean(clicPourObjetSuivant);
  }  
}
