/**
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import java.io.*;
import java.awt.Color;

import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

public abstract class CMacroAvecListe extends CMacro {
	public CSousListeObjets listeAssociee;

  /** Creates new CMacroAvecListe */
  public CMacroAvecListe() {
    listeAssociee = new CSousListeObjets();
  }
  
  // Constructeur pour clonage
  public CMacroAvecListe(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
      Color couleurInit, double x_nomInit, double y_nomInit, double dec_xInit, double dec_yInit, boolean masqueInit,
      CPointAncetre pointLieInit, int indiceTaillePoliceInit, int encadrementInit,
      boolean effacementFondInit, Color couleurFondInit, String intituleInit, String commentaireMacroInit,
      CSousListeObjets listeAssocieeInit, int alignementHorizontalInit, int alignementVerticalInit) {
        super (liste, impProtoInit, estElementFinalInit, couleurInit, x_nomInit, y_nomInit,
          dec_xInit, dec_yInit, masqueInit, pointLieInit,
          indiceTaillePoliceInit, effacementFondInit, couleurFondInit,
          intituleInit, commentaireMacroInit, alignementHorizontalInit, alignementVerticalInit);
        listeAssociee = listeAssocieeInit;
  }

  public boolean dependDe(CElementBase p) {
  	if (elementTestePourDependDe == p) return dependDeElementTeste;
    return memoriseDependance(super.dependDe(p) || listeAssociee.dependDe(p));
  }
  
  public boolean dependDePourBoucle(CElementBase p) {
    return super.dependDePourBoucle(p) || listeAssociee.dependDePourBoucle(p);
  }

  @Override
  public boolean ajoutOuRetraitObjetsPossible() {
  	return true;
  }
  
  public boolean executionPossible() {
    return listeAssociee.existeAuMoinsUnElement();
  }
  
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    listeAssociee.chargeDepuisFlux(inps, list);
  }
  /* Lecture depuis dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    listeAssociee.read(inps, list);
  }  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    listeAssociee.write(oups, listeProprietaire);
  }  
}