/*
 * CMacroAvecListe.java
 *
 * Created on 4 aot 2004, 19:26
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import java.io.*;
import java.awt.Color;

import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

public abstract class CMacroAvecListe extends CMacro {
	public CSousListeObjets listeAssociee;

  /** Creates new CMacroAvecListe */
  public CMacroAvecListe() {
    listeAssociee = new CSousListeObjets();
  }
  
  // Constructeur pour clonage
  public CMacroAvecListe(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
      Color couleurInit, double x_nomInit, double y_nomInit, double dec_xInit, double dec_yInit, boolean masqueInit,
      CPointAncetre pointLieInit, int indiceTaillePoliceInit, int encadrementInit,
      boolean effacementFondInit, Color couleurFondInit, String intituleInit, String commentaireMacroInit,
      CSousListeObjets listeAssocieeInit) {
        super (liste, impProtoInit, estElementFinalInit, couleurInit, x_nomInit, y_nomInit,
          dec_xInit, dec_yInit, masqueInit, pointLieInit,
          indiceTaillePoliceInit, effacementFondInit, couleurFondInit,
          intituleInit, commentaireMacroInit);
        listeAssociee = listeAssocieeInit;
  }

  public boolean dependDe(CElementBase p) {
    return super.dependDe(p) || listeAssociee.dependDe(p);
  }
  
  public boolean dependDePourBoucle(CElementBase p) {
    return super.dependDePourBoucle(p) || listeAssociee.dependDePourBoucle(p);
  }

  /**
   * Fonction renvoyant true seulement si la macro descend de CMacroAvecListe
   * Redfini seulement pour CMacroAvecListe
   * @return
   */
  public boolean estMacroAvecListe() {
  	return true;
  }
  
  public boolean executionPossible() {
    return listeAssociee.existeAuMoinsUnElement();
  }
  
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    listeAssociee.chargeDepuisFlux(inps, list);
  }
  /* Lecture depuis dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    listeAssociee.read(inps, list);
  }  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    listeAssociee.write(oups, listeProprietaire);
  }  
}