/*
 * CMacroPause.java
 *
 * Created on 19 aot 2004, 11:22
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import java.io.*;
import java.awt.Color;
import Applet.AppletMathGraph32;
import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

public class CMacroPause extends CMacro {
	public int dureePause; // Dure de la pause en secondes

  /** Creates new CMacroPause */
  public CMacroPause() {
  }
  
  // Constructeur pour clonage
  public CMacroPause(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
      Color couleurInit, double x_nomInit, double y_nomInit, double dec_xInit, double dec_yInit, boolean masqueInit,
      CPointAncetre pointLieInit, int indiceTaillePoliceInit,
      boolean effacementFondInit, Color couleurFondInit, String intituleInit, String commentaireMacroInit, int dureePauseInit) {
        super (liste, impProtoInit, estElementFinalInit, couleurInit, x_nomInit, y_nomInit,
          dec_xInit, dec_yInit, masqueInit, pointLieInit, indiceTaillePoliceInit,
          effacementFondInit, couleurFondInit, intituleInit, commentaireMacroInit);
        dureePause = dureePauseInit;
  }

  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(pointLie);  
    int ind2 = listeSource.indexOf(impProto);        
    CElementBase ptelb = new CMacroPause(listeCible, (CImplementationProto)(listeCible.get(ind2, CImplementationProto.class)),
      estElementFinal, couleur, x_nom, y_nom, dec_x, dec_y, masque,
      (CPointAncetre)listeCible.get(ind1, CPointAncetre.class), indiceTaillePolice,
      effacementFond, couleurFondAffichage, intitule, commentaireMacro, dureePause);
    return ptelb;
  }
    
  @Override
  public long dureePourAnimation() {
    return dureePause;
  }

  @Override
  public void actionAvantExecution(AppletMathGraph32 applet) {
  	super.actionAvantExecution(applet);
    timeDebut = System.currentTimeMillis();
    timeFin = timeDebut + dureePause*100; // La dure est en diximes de secondes
  }

  @Override
  public int typeAnimation() {
    return CMacro.animationParTimer;
  }

  @Override
  public int frequenceAnimation() {
    return 10; // On utilise un timer au centime de seconde
  }

  @Override
  public void actionDansPaint(AppletMathGraph32 applet) {
    // ne fait rien
  }
    
  @Override
  public boolean executionPossible() {
    return true;
  }
  
  @Override
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    dureePause = inps.readCInt();
  }

  /* Lecture depuis dans un flux java */  
  @Override
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    dureePause = inps.readInt();
  }
  
  /* Enregistrement dans un flux java */
  @Override
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    oups.writeInt(dureePause);
  }
}
