/*
 * CNoeudPondere.java
 *
 * Created on 9 juillet 2004, 17:05
 */
package objets;

/**
 *
 * @author  Yves
 * @version 
 */
// Classe noeud pondr dont les instances servent  construire des barycentres
import java.io.*;

import types.DimensionFenetre;

import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

public class CNoeudPondere extends CObjetBase {
	public CPointAncetre pointAssocie;
	public CValeurAssocieeAVariable poids;
	// Ajout pour version 3.0
	public boolean existe;

  /** Creates new CNoeudPondere */
  public CNoeudPondere() {
  }
    
  // Constructeur pour clonage
  public CNoeudPondere(CListeObjets liste, CPointAncetre pointAssocieInit,
      CValeurAssocieeAVariable poidsInit) {
    super(liste);
    pointAssocie = pointAssocieInit;
    poids = poidsInit;
  }

  public CNoeudPondere getClone(CListeObjets listeSource, CListeObjets listeCible) {
    CValeurAssocieeAVariable poidsClone = (CValeurAssocieeAVariable) poids.getClone(listeSource, listeCible);
    int ind1 = listeSource.indexOf(pointAssocie);
    return new CNoeudPondere(listeCible, (CPointAncetre)(listeCible.get(ind1, CPointAncetre.class)), poidsClone);  
  }
  
  // Ajout pour version 3.0
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
  	poids.positionne(infoRandom, dimfen);
  	existe = poids.existe();
  }

  public void remplacePoint(CPointAncetre ancienPoint, CPointAncetre nouveauPoint) {
    if (pointAssocie == ancienPoint) pointAssocie = nouveauPoint;
  }
  
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    poids = new CValeurAssocieeAVariable();
    poids.chargeDepuisFlux(inps, list);
    int ind1 = inps.readCInt();
    pointAssocie = (CPointAncetre) (list.get(ind1,CPointAncetre.class));
  }
  /* Lecture depuis dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    poids = new CValeurAssocieeAVariable();
    poids.read(inps, list);
    int ind1 = inps.readInt();
    pointAssocie = (CPointAncetre) (list.get(ind1,CPointAncetre.class));
  }  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    poids.write(oups, list);
    int ind1 = list.indexOf(pointAssocie);
    oups.writeInt(ind1);
  }   
}
