/*
 * CObjetBase.java
 *
 * Created on 3 juillet 2004, 17:39
 */

/**
 *
 * @author  Yves
 * @version 
 */
// Classe anctre de tous les objets qui devront tre chargs depuis un flux
// Grosse nouveaut pour la version Java : chaque objet, y compris les objets de type calcul
// aura un membre listePropritaire
// qui contiendra une rfrence  la liste principale qui contient l'objet.
// Ce membre sera table lors de l'appel  ChargeDepuisFlux
package objets;

import java.io.*;

import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

public abstract class CObjetBase extends java.lang.Object {
  // Pointeur sur la liste possdant l'objet
  public CListeObjets listeProprietaire;
  // Numro de version de l'objet. 1 par dfaut.
  // A redfinir pour les objets ayant eu un numro de version redfini en C++ ou java
  public int numeroVersion() {
  	return 1;
  }
  // A partir de la version 1.8, numro de version gr
  public int nVersion;

  /** Creates new CObjetBase */
  public CObjetBase() {
  	nVersion = numeroVersion();
  }
  
  public CObjetBase(CListeObjets liste){
    listeProprietaire = liste;
  	nVersion = numeroVersion();
  }
  // Chargement depuis un flux C++
  public void chargeDepuisFlux ( MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    listeProprietaire = list;
  }
  // Nouvelles procdures de serialization java
  /* Chargement depuis un flux java */
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    listeProprietaire = list;
  }
  /* Enregistrement dans un flux java. A redefinir pour les descendants */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
  }
    

}
