/*
 * CPointLiePoint.java
 *
 * Created on 9 juillet 2004, 16:38
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

// Attention java :dans la version C++ CPointLiePoint drivait de CPointLie mais n'appelait

import java.awt.Color;
import java.awt.geom.Point2D;
import java.io.IOException;
import types.DimensionFenetre;
import types.Doub;
import types.NatureObjet;
import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

// pas sa srialization. C'est impossible en java donc il drive en java de CPointAncetre

public class CPointLiePoint extends CPointAncetre {
	CPointAncetre pointAssocie;

  /** Creates new CPointLiePoint */
  public CPointLiePoint() {
  }
  
  // Pour satisfaire lengthcompilateur
  public boolean testDeplacement(DimensionFenetre dimfen, double xtest, double ytest,
        Point2D.Double pointr, Doub abscr) {
    return true;
  }
  

  // Constructeur pour clonage
  public CPointLiePoint(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
        Color couleurInit, boolean nomMasqueInit, double dec_xInit, double dec_yInit, boolean masqueInit, String nomInit, int indiceTailleNomInit,
        int motifInit, CPointAncetre pointAssocieInit) {
     super (liste, impProtoInit, estElementFinalInit, couleurInit, nomMasqueInit,
       dec_xInit, dec_yInit, masqueInit, nomInit, indiceTailleNomInit, motifInit);
     pointAssocie = pointAssocieInit;
  }

  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(pointAssocie);
    int ind2 = listeSource.indexOf(impProto);        
    CElementBase ptelb = new CPointLiePoint(listeCible, (CImplementationProto)(listeCible.get(ind2, CImplementationProto.class)),
      estElementFinal, couleur, nomMasque, dec_x, dec_y, masque, nom, indiceTailleNom,
      motif, (CPointAncetre)(listeCible.get(ind1, CPointAncetre.class)));
    return ptelb;
  }
  
  public boolean dependDe(CElementBase p) {
    return super.dependDe(p) || pointAssocie.dependDe(p);
  }

  public boolean dependDePourBoucle(CElementBase p) {
    return ((p == this) || pointAssocie.dependDePourBoucle(p));
  }


  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    existe = pointAssocie.existe;
    if (existe)  super.placeEn(pointAssocie.x, pointAssocie.y);
  }

  CElementBase lieA() {
    return pointAssocie;
  }
  
  @Override
  public long getNature() {
    return NatureObjet.NPointLiePoint;
  }
  
  @Override
  public boolean confonduAvec(CElementBase p) {
    CPointLiePoint pt;
    if (p.getClass() == this.getClass()) {
      pt = (CPointLiePoint) p;
      return (pointAssocie == pt.pointAssocie);
    }
    else return false;
  }
  
  public void remplacePoint(CPointAncetre ancienPoint, CPointAncetre nouveauPoint) {
    if (pointAssocie == ancienPoint) pointAssocie = nouveauPoint;
  }
  
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    int ind1 = inps.readCInt();
    pointAssocie = (CPointAncetre) (list.get(ind1,CPointAncetre.class));
  }
  
  /* Chargement depuis un flux java */
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    int ind1 = inps.readInt();
    pointAssocie = (CPointAncetre) (list.get(ind1,CPointAncetre.class));
  }
  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    int ind1 = list.indexOf(pointAssocie);
    oups.writeInt(ind1);
  }
}
