/*
 * CPointParAffixe.java
 *
 * Created on 28 janvier 2007, 18:05
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objets;

import java.awt.Color;
import java.io.IOException;
import types.Complexe;
import types.DimensionFenetre;
import types.NatureObjet;
import types.VecteurDirecteur;
import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

/**
 *
 * @author Yves
 */
public class CPointParAffixe extends CPointAncetre {
  public CRepere rep;
  public CValeurAssocieeComp affixe;
  // Attribut ajout pour optimisation 
  private Complexe z1 = new Complexe();
  
  /** Creates a new instance of CPointParAffixe */
  public CPointParAffixe() {
    affixe = new CValeurAssocieeComp();
  }
  // Constructeur pour clonage
  public CPointParAffixe(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
      Color couleurInit, boolean nomMasqueInit, double dec_xInit, double dec_yInit,
      boolean masqueInit, String nomInit, int indiceTailleNomInit,
      int motifInit , CRepere repInit, CValeurAssocieeComp affixeInit) {
    super(liste, impProtoInit, estElementFinalInit, couleurInit, nomMasqueInit, dec_xInit, dec_yInit,
      masqueInit, nomInit, indiceTailleNomInit, motifInit);
    rep = repInit;
    affixe = affixeInit;
  }
  
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(rep);
    int ind2 = listeSource.indexOf(impProto);        
    CValeurAssocieeComp affixeClone = (CValeurAssocieeComp) affixe.getClone(listeSource, listeCible);
    return new CPointParAffixe(listeCible, (CImplementationProto)(listeCible.get(ind2, CImplementationProto.class)),
      estElementFinal, couleur, nomMasque, dec_x, dec_y, masque, nom,
          indiceTailleNom, motif, (CRepere)(listeCible.get(ind1, CRepere.class)), affixeClone);
  }
  
  public boolean dependDe(CElementBase p) {
    return super.dependDe(p) || rep.dependDe(p) || affixe.dependDe(p);
  }
  
  public boolean dependDePourBoucle(CElementBase p) {
    return ((p == this) || rep.dependDePourBoucle(p) || affixe.dependDePourBoucle(p));
  }
  
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
  	affixe.positionne(infoRandom, dimfen);
    existe = affixe.existe() && rep.existe;
    if (!existe) return;
    affixe.rendValeurComplexe(infoRandom, z1);
    VecteurDirecteur vec = new VecteurDirecteur();
    vec.x = z1.x*rep.u.x + z1.y*rep.v.x;
    vec.y = z1.x*rep.u.y + z1.y*rep.v.y;
    x = rep.origine.x + vec.x;
    y = rep.origine.y + vec.y;
    super.positionne(infoRandom, dimfen);
  }
  @Override
  public long getNature() {
    return NatureObjet.NPointParAffixe;
  }
  
  @Override
  public boolean confonduAvec(CElementBase p) {
    CPointParAffixe pt;
    if (p.getClass() == this.getClass()) {
      pt = (CPointParAffixe) p;
      return (rep == pt.rep) && affixe.confonduAvec(pt.affixe);
    }
    else return false;
  }        

  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    int ind1 = inps.readCInt();
    rep = (CRepere) (list.get(ind1,CRepere.class));
    affixe.chargeDepuisFlux(inps, list);
  }  
  /* Chargement depuis un flux java */
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    int ind1 = inps.readInt();
    rep = (CRepere) (list.get(ind1,CRepere.class));
    affixe = new CValeurAssocieeComp();
    affixe.read(inps, list);
  }  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    int ind1 = list.indexOf(rep);
    oups.writeInt(ind1);
    affixe.write(oups, list);
  }
}
