/*
 * CRepere.java
 *
 * Created on 12 juillet 2004, 10:22
 */

/**
 *
 * @author  Yves
 * @version
 */
package objets;

import java.awt.geom.*;
import java.awt.*;
import java.io.*;
import types.*;
import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;
import glob.*;


public class CRepere extends CElementLigne {
  private double absMiniH,absMaxiH;
  private double absMiniV,absMaxiV;
  
  public CPointAncetre O;
  public CPointAncetre I;
  public CPointAncetre J;
  VecteurDirecteur u,v;
  Point2D.Double origine;
  public CValeurAssocieeAVariable abscisseOrigine;
  public CValeurAssocieeAVariable ordonneeOrigine;
  // public CDroite axeAbscisses; Abandonn pour la version java
  // public CDroite axeOrdonnees; Abandonn pour la version java
  public boolean quadrillageHorizontal;
  public boolean quadrillageVertical;
  public boolean pointilles;
  // Pour le positionnement
  private Point2D.Double[] pointint = new Point2D.Double[4];
  
  // Java : diffrence par rapport au C++
  // La droite servant  tracer les quadrillages est cre  la cration de l'objet CRepere
  // et le servant  tracer des pointills et ce point est du type CPointBase
  // Autre grosse diffrence : la mthode de tracage a besoin de connatre les dimensions de la
  // fentre pour le trac des quadrillages. La variable membre dimensionsFenetre mmorisera donc
  // cette valeur dans positionne() ainsi que celle de infoRandom dans infoSurRandom
  private boolean infoSurRandom;
  private DimensionFenetre dimensionFenetre;
  
  
  CDroite droiteQuadrillage;
  CPointBase pointPointilles;
  
  
  public CRepere() {
  }
  
  // Constructeur pour clonage
  public CRepere(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
    Color couleurInit, boolean masqueInit, int styleInit, CPointAncetre OInit, CPointAncetre IInit, CPointAncetre JInit,
    CValeurAssocieeAVariable abscisseOrigineInit, CValeurAssocieeAVariable ordonneeOrigineInit,
    boolean quadrillageHorizontalInit, boolean quadrillageVerticalInit, boolean pointillesInit) {
    super(liste, impProtoInit, estElementFinalInit,  couleurInit, masqueInit, styleInit);
    u = new VecteurDirecteur();
    v = new VecteurDirecteur();
    droiteQuadrillage = new CDroite(liste);	// On donne une liste propritaire pour que la droite soit adapte
    																				//  la haure ou basse rsolution
    droiteQuadrillage.montre();
    pointPointilles = new CPointBase(liste);
    pointPointilles.donneMotif(MotifPoint.pixel);
    pointPointilles.montre();
    origine = new Point2D.Double();
    O = OInit;
    I = IInit;
    J = JInit;
    abscisseOrigine = abscisseOrigineInit;
    ordonneeOrigine = ordonneeOrigineInit;
    quadrillageHorizontal = quadrillageHorizontalInit;
    quadrillageVertical = quadrillageVerticalInit;
    pointilles = pointillesInit;
    // Crer le tableau ne suffit pas, il faut instancier chaque membre
    for (int i = 0; i < 4; i++) {
      pointint[i] = new Point2D.Double();
    }
  }
  
  @Override
  public void setClone(CElementBase ptel) {
    super.setClone(ptel);
    absMiniH = ((CRepere)ptel).absMiniH;
    absMaxiH = ((CRepere)ptel).absMaxiH;
    absMiniV = ((CRepere)ptel).absMiniV;
    absMaxiV = ((CRepere)ptel).absMaxiV;
    infoSurRandom = ((CRepere)ptel).infoSurRandom;
    dimensionFenetre = ((CRepere)ptel).dimensionFenetre;
    origine.setLocation(((CRepere)ptel).origine);
    ((CRepere)ptel).u.setCopy(u);
    ((CRepere)ptel).v.setCopy(v);
  }
  
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(O);
    int ind2 = listeSource.indexOf(I);
    int ind3 = listeSource.indexOf(J);
    int ind4 = listeSource.indexOf(impProto);
    CValeurAssocieeAVariable abscisseOrigineClone =
      (CValeurAssocieeAVariable) abscisseOrigine.getClone(listeSource, listeCible);
    CValeurAssocieeAVariable ordonneeOrigineClone =
      (CValeurAssocieeAVariable) ordonneeOrigine.getClone(listeSource, listeCible);
    CElementBase ptelb = new CRepere(listeCible, (CImplementationProto)(listeCible.get(ind4, CImplementationProto.class)),
      estElementFinal, couleur, masque, style,
      (CPointAncetre)(listeCible.get(ind1, CPointAncetre.class)),
      (CPointAncetre)(listeCible.get(ind2, CPointAncetre.class)),
      (CPointAncetre)(listeCible.get(ind3, CPointAncetre.class)),
      abscisseOrigineClone, ordonneeOrigineClone, quadrillageVertical,
      quadrillageHorizontal, pointilles);
    return ptelb;
  }
  
  public boolean dependDe(CElementBase p) {
    return super.dependDe(p)
    || O.dependDe(p)
    || I.dependDe(p)
    || J.dependDe(p)
    || abscisseOrigine.dependDe(p)
    || ordonneeOrigine.dependDe(p);
  }
  
  public boolean dependDePourBoucle(CElementBase p) {
    return ((p == this)
    || O.dependDePourBoucle(p)
    || I.dependDePourBoucle(p)
    || J.dependDePourBoucle(p)
    || abscisseOrigine.dependDePourBoucle(p)
    || ordonneeOrigine.dependDePourBoucle(p));
  }
  
  @Override
  public boolean nomIndispensable(CElementGraphique el) {
    return ((el == O) || (el == I) || (el == J));
  }
  
  
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    abscisseOrigine.positionne(infoRandom, dimfen);
    ordonneeOrigine.positionne(infoRandom, dimfen);
    existe = (O.existe) && (I.existe) && (J.existe)
    	&& (abscisseOrigine.existe())
    	&& (ordonneeOrigine.existe())
    	&& !(Kernel.aligne(O.x,O.y,I.x,I.y,J.x,J.y));
    if (existe) {
      double abs[] = new double[4];
      Point pointIndices = new Point(); // Contiendra les indices des valeurs minimalse et maximales
      // Java : diffrence par rapport au C++. Ncessaire de mmoriser infoRandom et dimfen
      // pour lengthtrac de la droite servant au quadrillage
      infoSurRandom = infoRandom;
      dimensionFenetre = dimfen;
      u.setVecteur(O,I);
      v.setVecteur(O,J);
      // On calcule les relles coordonnes de l'origine
      origine.x = O.x - u.x*abscisseOrigine.rendValeur(infoRandom)-v.x*ordonneeOrigine.rendValeur(infoRandom);
      origine.y = O.y - u.y*abscisseOrigine.rendValeur(infoRandom)-v.y*ordonneeOrigine.rendValeur(infoRandom);
      // Prparation du quadrillage vertical ventuel;
      if (quadrillageVertical || pointilles) {
        Kernel.intersectionDroitesSecantes(0,0,u,O.x,O.y,v,pointint[0]);
        Kernel.intersectionDroitesSecantes
          (0,dimfen.longueurOrdonnees,u,O.x,O.y,v,pointint[1]);
        Kernel.intersectionDroitesSecantes
          (dimfen.longueurAbscisses,0,u,O.x,O.y,v,pointint[2]);
        Kernel.intersectionDroitesSecantes
          (dimfen.longueurAbscisses,dimfen.longueurOrdonnees,u,O.x,O.y,v,pointint[3]);
        if (v.y != 0) {
          abs[0] = (pointint[0].y-O.y)/v.y;
          abs[1] = (pointint[1].y-O.y)/v.y;
          abs[2] = (pointint[2].y-O.y)/v.y;
          abs[3] = (pointint[3].y-O.y)/v.y;
        } else {
          abs[0] = (pointint[0].x-O.x)/v.x;
          abs[1] = (pointint[1].x-O.x)/v.x;
          abs[2] = (pointint[2].x-O.x)/v.x;
          abs[3] = (pointint[3].x-O.x)/v.x;
        };
        Kernel.indiceMiniMaxi((byte)3,abs,pointIndices);
        absMiniV = Math.floor(abs[pointIndices.x]+1);
        absMaxiV = Math.floor(abs[pointIndices.y]);
        
      }
      if (quadrillageHorizontal || pointilles) {
        Kernel.intersectionDroitesSecantes(0,0,v,O.x,O.y,u,pointint[0]);
        Kernel.intersectionDroitesSecantes
          (0,dimfen.longueurOrdonnees,v,O.x,O.y,u,pointint[1]);
        Kernel.intersectionDroitesSecantes
          (dimfen.longueurAbscisses,0,v,O.x,O.y,u,pointint[2]);
        Kernel.intersectionDroitesSecantes
          (dimfen.longueurAbscisses,dimfen.longueurOrdonnees,v,O.x,O.y,u,pointint[3]);
        if (u.x != 0) {
          abs[0] = (pointint[0].x - O.x)/u.x;
          abs[1] = (pointint[1].x - O.x)/u.x;
          abs[2] = (pointint[2].x - O.x)/u.x;
          abs[3] = (pointint[3].x - O.x)/u.x;
        } else {
          abs[0] = (pointint[0].y - O.y)/u.y;
          abs[1] = (pointint[1].y - O.y)/u.y;
          abs[2] = (pointint[2].y - O.y)/u.y;
          abs[3] = (pointint[3].y - O.y)/u.y;
        }
        Kernel.indiceMiniMaxi((byte)3,abs,pointIndices);
        absMiniH = Math.floor(abs[pointIndices.x]+1);
        absMaxiH = Math.floor(abs[pointIndices.y]);
      }
    }
  }

  @Override
  public void trace(Graphics2D pDC, Color couleurFond, float transparence) {
    
    if (quadrillageVertical) {
      droiteQuadrillage.donneCouleur(couleur);
      droiteQuadrillage.donneStyle(style); // Contrairement  la version java les repres ont un style
      if (absMaxiV - absMiniV <= 50) {
        droiteQuadrillage.vecteur.x = u.x;
        droiteQuadrillage.vecteur.y = u.y;
        for (double p = absMiniV;p <= absMaxiV; p++) {
          if (p != 0) {
            droiteQuadrillage.point_x = O.x + p*v.x;
            droiteQuadrillage.point_y = O.y + p*v.y;
            // Les paramtres d'appel ne servent pas.
            droiteQuadrillage.positionne(infoSurRandom, dimensionFenetre);
            droiteQuadrillage.trace(pDC, couleurFond, transparence);
          }
        }
      }
    }
    if (quadrillageHorizontal) {
      droiteQuadrillage.donneCouleur(couleur);
      droiteQuadrillage.donneStyle(style);
      
      if (absMaxiH - absMiniH <= 50) {
        droiteQuadrillage.vecteur.x = v.x;
        droiteQuadrillage.vecteur.y = v.y;
        for (double p = absMiniH;p <= absMaxiH; p++) {
          if (p != 0) {
            droiteQuadrillage.point_x = O.x + p*u.x;
            droiteQuadrillage.point_y = O.y + p*u.y;
            droiteQuadrillage.positionne(infoSurRandom, dimensionFenetre);
            droiteQuadrillage.trace(pDC, couleurFond, transparence);
          }
        }
      }
    }
    if (pointilles) {
      pointPointilles.donneCouleur(couleur);
      
      if ((absMaxiH - absMiniH <= 50)
      		&& (absMaxiV - absMiniV <= 50)) {
        for (double p = absMiniH;p <= absMaxiH; p++) {
          for (double q = absMiniV;q <= absMaxiV; q++) {
            double x1 = O.x + p*u.x +q*v.x;
            double y1 = O.y + p*u.y + q*v.y;
            pointPointilles.placeEn(x1,y1);
            pointPointilles.trace(pDC, couleurFond, transparence);
          }
        }
      }
    }
  }
  
  @Override
  public boolean confonduAvec(CElementBase p) {
    CRepere pt;
    if (p.getClass() == this.getClass()) {
      pt = (CRepere) p;
   		return (O == pt.O) && (I == pt.I) && (J == pt.J);
    }
    else return false;
  }        
    
  public void remplacePoint(CPointAncetre ancienPoint, CPointAncetre nouveauPoint) {
    if (O == ancienPoint) O = nouveauPoint;
    if (I == ancienPoint) I = nouveauPoint;
    if (J == ancienPoint) J = nouveauPoint;
  }

  // Attention : Dans la version java, le repre est le seul objet  la fois graphique et non graphique
  // Il est considr comme non graphique car dans les constructions il est choisi en premier dans
  // les objets non graphiques  
  @Override
  public long getNatureCalcul() {
    return NatureCalcul.NRepere;
  }
  
  @Override
  public long getNature() {
  	return NatureObjet.NRepere;
  }
    
  
  @Override
  public String nom() {
  	return "(" + O.rendNom() + "," + I.rendNom() + "," + J.rendNom() + ")";
  }
  
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    // A cause d'une erreur de conception de la version C++ qui appelait la srialization
    // de CElementGraphique alors que l'objet drive de CElementLigne.
    // Il a donc fallu que je rajoute un ancetre de tous les CElementLigne !
    super.chargeDepuisFluxSansStyleTrait(inps, list);
  	abscisseOrigine = new CValeurAssocieeAVariable(listeProprietaire, 0);
  	ordonneeOrigine = new CValeurAssocieeAVariable(listeProprietaire, 0);
    u = new VecteurDirecteur();
    v = new VecteurDirecteur();
    droiteQuadrillage = new CDroite(list);
    droiteQuadrillage.donneStyle(StyleTrait.traitPointille);
    droiteQuadrillage.montre();
    pointPointilles = new CPointBase(list);
    pointPointilles.donneMotif(MotifPoint.pixel);
    pointPointilles.montre();
    origine = new Point2D.Double();
    
    style = StyleTrait.traitPointille;
    if (this.nVersion == 1) { // Spcifique vieille version
			@SuppressWarnings("unused")
			byte b1 = inps.readByte();
    }
    int ind1 = inps.readCInt();
    int ind2 = inps.readCInt();
    int ind3 = inps.readCInt();
    @SuppressWarnings("unused")
		int ind4 = inps.readCInt(); // Servait  charger l'axe des abscisses en C++. Abandonn
    @SuppressWarnings("unused")
		int ind5 = inps.readCInt(); // Servait  charger l'axe des ordonnes en C++. Abandonn
    O = (CPointAncetre) (list.get(ind1,CPointAncetre.class));
    I = (CPointAncetre) (list.get(ind2,CPointAncetre.class));
    J = (CPointAncetre) (list.get(ind3,CPointAncetre.class));
    quadrillageVertical = inps.readBoolean();
    quadrillageHorizontal = inps.readBoolean();
    pointilles = inps.readBoolean();
    abscisseOrigine = new CValeurAssocieeAVariable(list, 0);
    ordonneeOrigine = new CValeurAssocieeAVariable(list, 0);
    // La version 1 ne permettait pas de dcaler l'origine du repre
    if (nVersion != 1) {
    	abscisseOrigine.chargeDepuisFlux(inps, list);
    	ordonneeOrigine.chargeDepuisFlux(inps, list);
    }
    nVersion = numeroVersion(); // On remet tout  zro pour la version java
  }
  /* Chargement depuis un flux java */
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
  	abscisseOrigine = new CValeurAssocieeAVariable(listeProprietaire, 0);
  	ordonneeOrigine = new CValeurAssocieeAVariable(listeProprietaire, 0);
    u = new VecteurDirecteur();
    v = new VecteurDirecteur();
    droiteQuadrillage = new CDroite(list);
    droiteQuadrillage.donneStyle(StyleTrait.traitPointille);
    droiteQuadrillage.montre();
    pointPointilles = new CPointBase(list);
    pointPointilles.donneMotif(MotifPoint.pixel);
    pointPointilles.montre();
    origine = new Point2D.Double();
    // Crer le tableau ne suffit pas, il faut instancier chaque membre
    for (int i = 0; i < 4; i++) {
      pointint[i] = new Point2D.Double();
    }
    int ind1 = inps.readInt();
    int ind2 = inps.readInt();
    int ind3 = inps.readInt();
    O = (CPointAncetre) (list.get(ind1,CPointAncetre.class));
    I = (CPointAncetre) (list.get(ind2,CPointAncetre.class));
    J = (CPointAncetre) (list.get(ind3,CPointAncetre.class));
    quadrillageVertical = inps.readBoolean();
    quadrillageHorizontal = inps.readBoolean();
    pointilles = inps.readBoolean();
    abscisseOrigine = new CValeurAssocieeAVariable();
    abscisseOrigine.read(inps, list);
    ordonneeOrigine = new CValeurAssocieeAVariable();
    ordonneeOrigine.read(inps, list);  
  }
  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    // Crer le tableau ne suffit pas, il faut instancier chaque membre
    for (int i = 0; i < 4; i++) {
      pointint[i] = new Point2D.Double();
    }
    int ind1 = list.indexOf(O);
    oups.writeInt(ind1);
    int ind2 = list.indexOf(I);
    oups.writeInt(ind2);
    int ind3 = list.indexOf(J);
    oups.writeInt(ind3);
    oups.writeBoolean(quadrillageVertical);
    oups.writeBoolean(quadrillageHorizontal);
    oups.writeBoolean(pointilles);
    abscisseOrigine.write(oups, list);
    ordonneeOrigine.write(oups, list);
  }
}
