/*
 * CSomme.java
 *
 * Created on 20 octobre 2007, 12:40
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objets;
import java.io.*;
import types.*;
import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

/**
 *
 * @author Yves
 */
/* Classe ajoute pour la version 2.5 */
public class CSomme extends CCalculAncetre {
  private final static int NombreMaxiTermesSomme = 5000;
  // La liste des lments de la figure dont dpendra la somme indice
  CListeObjets listeElementsAncetres;
  
  public CVariableBornee indice;
  public CValeurDynamique valeurASommer;
  // Les bornes de l'intervalle de sommation
  public CValeurAssocieeAVariable indiceMin;
  public CValeurAssocieeAVariable indiceMax;
  double valeurSomme;
  /** Creates a new instance of CSomme */
  public CSomme() {
  }
  
  // Constructeur pour clonage
  public CSomme(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
    String nomCalculInit, CVariableBornee indiceInit, CValeurDynamique valeurASommerInit,
    CValeurAssocieeAVariable indiceMinInit, CValeurAssocieeAVariable indiceMaxInit) {
    super(liste, impProtoInit, estElementFinalInit,  nomCalculInit);
    indice = indiceInit;
    valeurASommer = valeurASommerInit;
    indiceMin = indiceMinInit;
    indiceMax = indiceMaxInit;
    // Il faut crer la liste des lments dont dpend le point  tracer
    // Cette liste sera finie d'tre valide dans setClone()
    listeElementsAncetres = new CListeObjets();
  }
  
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(indice);
    int ind2 = listeSource.indexOf(valeurASommer);
    int ind3 = listeSource.indexOf(impProto);    
    CValeurAssocieeAVariable indiceMinClone = (CValeurAssocieeAVariable) indiceMin.getClone(listeSource, listeCible);
    CValeurAssocieeAVariable indiceMaxClone = (CValeurAssocieeAVariable) indiceMax.getClone(listeSource, listeCible);
    CElementBase ptelb = new CSomme(listeCible, (CImplementationProto)(listeCible.get(ind3, CImplementationProto.class)),
      estElementFinal, nomCalcul, (CVariableBornee)(listeCible.get(ind1, CVariableBornee.class)),
      (CValeurDynamique)listeCible.get(ind2, CValeurDynamique.class), indiceMinClone, indiceMaxClone);
    if (listeCible.getClass() != CPrototype.class) {    
	    ((CSomme)ptelb).listeElementsAncetres.setImage(listeElementsAncetres, listeProprietaire,
	      ptelb.listeProprietaire);
    }
    return ptelb;
  }
  
  @Override
  public long getNatureCalcul() {
  	return NatureCalcul.NSommeIndicee;
  }
  
  public boolean dependDe(CElementBase p) {
    return super.dependDe(p) || indice.dependDe(p) || valeurASommer.dependDe(p)
    || indiceMin.dependDe(p) || indiceMax.dependDe(p);
  }
  
  public boolean dependDePourBoucle(CElementBase p) {
    return (p == this) || indice.dependDePourBoucle(p) || valeurASommer.dependDePourBoucle(p)
    || indiceMin.dependDePourBoucle(p) || indiceMax.dependDePourBoucle(p);
  }
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
  	indiceMin.positionne(infoRandom, dimfen);
  	indiceMax.positionne(infoRandom, dimfen);
    existe = indiceMin.existe() && indiceMax.existe();
    if (!existe) return;
    // On arrondit les indices de dpart et de fin  l'entier le plus proche
    double indmin = Math.floor(indiceMin.rendValeur(infoRandom) + 0.5);
    double indmax = Math.floor(indiceMax.rendValeur(infoRandom) + 0.5);
    existe = (indmin <= indmax) && ((indmax - indmin) < NombreMaxiTermesSomme) ;
    if (!existe) return;
    double sauveIndice = indice.rendValeur(infoRandom);
    valeurSomme = 0;
    //  revoir : faut-il que la variable de boucle soit double ?
    for (double i = indmin; i <= indmax; i++)
    {
      indice.valeurActuelle = i;
      listeElementsAncetres.positionne(infoRandom, dimfen);
      existe = existe && valeurASommer.existe;
      valeurSomme = valeurSomme + valeurASommer.rendValeur(infoRandom);
    }
    indice.donneValeur(sauveIndice);
    listeElementsAncetres.positionne(infoRandom, dimfen);    
  }
  
  @Override
  public double rendValeur(boolean infoRandom) {
    return valeurSomme;
  }
  
  public void etablitListeElementsAncetres() {
  	listeElementsAncetres.retireTout();
    int indiceValeurASommer = listeProprietaire.indexOf(valeurASommer);
    for (int i = 0; i <= indiceValeurASommer; i++) {
      CElementBase ptelb = (CElementBase)(listeProprietaire.get(i));
      if ((ptelb != indice) && (valeurASommer.dependDe(ptelb)) && (ptelb.dependDe(indice)))
        listeElementsAncetres.add(ptelb);
    }  	
  }
  
  @Override
  public void metAJour() {
  	super.metAJour();
  	etablitListeElementsAncetres();
  }
  
   
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    // Il faut crer la liste des lments dont dpend le point  tracer
    // Pour cette liste, on fait pointer la longueur unit ventuelle sur la liste mre
    listeElementsAncetres = new CListeObjets(list.uniteAngle, list.pointeurLongueurUnite);
    int ind1 = inps.readCInt();
    indice = (CVariableBornee) (list.get(ind1,CVariableBornee.class));
    int ind2 = inps.readCInt();
    valeurASommer = (CValeurDynamique) (list.get(ind2,CValeurDynamique.class));
    indiceMin = new CValeurAssocieeAVariable();
    indiceMin.chargeDepuisFlux(inps, list);
    indiceMax = new CValeurAssocieeAVariable();
    indiceMax.chargeDepuisFlux(inps, list);
    // Modification pour la version 2.5.
    // Certaines choses pas  faire pour le chargement d'un prototype
    if (list.getClass() != CPrototype.class) {
    	etablitListeElementsAncetres();
    }    
  }
  /* Lecture depuis dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    // Il faut crer la liste des lments dont dpend le point  tracer
    // Pour cette liste, on fait pointer la longueur unit ventuelle sur la liste mre
    listeElementsAncetres = new CListeObjets(list.uniteAngle, list.pointeurLongueurUnite);
    int ind1 = inps.readInt();
    indice = (CVariableBornee) (list.get(ind1,CVariableBornee.class));
    int ind2 = inps.readInt();
    valeurASommer = (CValeurDynamique) (list.get(ind2,CValeurDynamique.class));
    indiceMin = new CValeurAssocieeAVariable();
    indiceMin.read(inps, list);
    indiceMax = new CValeurAssocieeAVariable();
    indiceMax.read(inps, list);
    // Modification pour la version 2.5.
    // Certaines choses pas  faire pour le chargement d'un prototype
    int indiceValeurASommer = list.indexOf(valeurASommer);
    if (list.getClass() != CPrototype.class) {
      for (int i = 0; i <= indiceValeurASommer; i++) {
        CElementBase ptelb = (CElementBase)(list.get(i));
        if ((ptelb != indice) && (valeurASommer.dependDe(ptelb)) && (ptelb.dependDe(indice)))
          listeElementsAncetres.add(ptelb);
      }
    }      
  }
  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    int ind1 = list.indexOf(indice);
    oups.writeInt(ind1);
    int ind2 = list.indexOf(valeurASommer);
    oups.writeInt(ind2);
    indiceMin.write(oups, list);
    indiceMax.write(oups, list);
  }
}
