/*
 * CSuiteRecComplexe.java
 *
 * Created on 29 janvier 2007, 13:17
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objets;
import java.io.*;
import types.*;
import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;


/**
 *
 * @author yves.biton
 */
public class CSuiteRecComplexe extends CCalculAncetre {
  public CFoncComplexe fonctionAssociee;
  public CValeurAssocieeAVariable nombreTermes;
  int nbt;
  public CValeurAssocieeComp premierTerme;
  int indiceDernierTermeExistant;
  Complexe[] valeurs; // Pointeur sur un tableau contenant les valeurs
  // des termes successifs
  // Attributs crs pour optimisation des calculs
  Complexe u = new Complexe();
  Complexe v = new Complexe();
  
  public CSuiteRecComplexe() {
  }
  
  /**
   * Constructeur pour cration d'objets
   * @param liste
   * @param nombreTermesInit
   * @param premierTermeInit
   */
  public CSuiteRecComplexe(CListeObjets liste, CValeurAssocieeAVariable nombreTermesInit, CValeurAssocieeComp premierTermeInit) {
  	super(liste, null, false, "");
  	fonctionAssociee = null;
    nombreTermes = nombreTermesInit;
    premierTerme = premierTermeInit;
    metAJourNombreTermes(); 	
  }
  
  // Constructeur pour clonage
  public CSuiteRecComplexe(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
    String nomCalculInit, CFoncComplexe fonctionAssocieeInit,
    CValeurAssocieeAVariable nombreTermesInit, CValeurAssocieeComp premierTermeInit) {
    super(liste, impProtoInit, estElementFinalInit, nomCalculInit);
    fonctionAssociee = fonctionAssocieeInit;
    nombreTermes = nombreTermesInit;
    premierTerme = premierTermeInit;
    metAJourNombreTermes();
  }
  
  static int NombreMaxiTermesSuiteRec = 2000;
  
  void metAJourNombreTermes() {
    double val = nombreTermes.rendValeur(false);
    if ((val == Math.floor(val)) && (val >= 1) && (val < NombreMaxiTermesSuiteRec)) nbt = (int) val;
    else nbt = 2; // Pas d'importance car dans ce cas la suite n'existe pas
    valeurs = new Complexe[nbt];
    for (int i =0; i < nbt; i++) valeurs[i] = new Complexe();
  }
  
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(fonctionAssociee);
    int ind2 = listeSource.indexOf(impProto);
    CValeurAssocieeComp premierTermeClone =
      (CValeurAssocieeComp) premierTerme.getClone(listeSource, listeCible);
    CValeurAssocieeAVariable nombreTermesClone =
      (CValeurAssocieeAVariable) nombreTermes.getClone(listeSource, listeCible);
    CElementBase ptelb = new CSuiteRecComplexe(listeCible, (CImplementationProto)(listeCible.get(ind2, CImplementationProto.class)),
      estElementFinal, nomCalcul, (CFoncComplexe)(listeCible.get(ind1, CFoncComplexe.class)), nombreTermesClone, premierTermeClone);
    return ptelb;
  }
  
  @Override
  public void setClone(CElementBase ptel) {
    super.setClone(ptel);
    indiceDernierTermeExistant = ((CSuiteRecComplexe) ptel).indiceDernierTermeExistant;
    for (int i = 0; i <= indiceDernierTermeExistant; i++) {
      valeurs[i].set(((CSuiteRecComplexe) ptel).valeurs[i]);
    }
  }
  
  public boolean dependDe(CElementBase p) {
    return super.dependDe(p) || premierTerme.dependDe(p) || fonctionAssociee.dependDe(p) || nombreTermes.dependDe(p);
  }
  
  public boolean dependDePourBoucle(CElementBase p) {
    return (p == this) || premierTerme.dependDePourBoucle(p) || fonctionAssociee.dependDePourBoucle(p)
    || nombreTermes.dependDePourBoucle(p);
  }
  
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    premierTerme.positionne(infoRandom, dimfen);
    nombreTermes.positionne(infoRandom, dimfen);
    existe = fonctionAssociee.existe && premierTerme.existe() && nombreTermes.existe();
    if (!existe) return;
    double dnbt = Math.floor(nombreTermes.rendValeur(false) + 0.5);
    existe = (dnbt >= 1) && (dnbt <= NombreMaxiTermesSuiteRec);
    if (!existe) return;
    if ((int) dnbt != nbt) {
      nbt = (int) dnbt;
      metAJourNombreTermes();
    }    
    premierTerme.rendValeurComplexe(infoRandom, u);
    valeurs[0].set(u);
    indiceDernierTermeExistant = 0;
    int i = 1;
    while (i < nbt) {
      try {
        fonctionAssociee.calcul.resultatFonctionComplexe(infoRandom, u, v);
        if (v.isNanOrInfinite())  break;
        u.set(v);
        valeurs[i].set(u);
        i++;
      } catch (ErreurCalculException e) {
        break;
      }
    }
    i--;
    indiceDernierTermeExistant = i;
  }
  
  @Override
	public boolean confonduAvec(CElementBase p) {
    CSuiteRecComplexe pt;
    if (p.getClass() == this.getClass()) {
      pt = (CSuiteRecComplexe) p;
      return (fonctionAssociee == pt.fonctionAssociee) && (premierTerme.confonduAvec(pt.premierTerme)
      		&& (nombreTermes.confonduAvec(pt.nombreTermes)));
    }
    else return false;
	}
 
  void rendValeurFonctionComplexe(boolean infoRandom, Complexe parametre, Complexe zRes)
  throws ErreurCalculException {
    if (!existe || (parametre.y != 0) || (parametre.x != Math.floor(parametre.x))
    || (parametre.x < 0) || (parametre.x > indiceDernierTermeExistant)) {
      throw new ErreurCalculException();
    } else zRes.set(valeurs[(int) parametre.x]);
  }
  
  /**
   * Pour savoir si le calcul est une fonction relle, une suite relle ou non
   * Redfini seulement pour CFonc, CFoncComplexe, CSuiteRec et CSuiteRecComplexe;
   */ 
  public boolean estFonctionOuSuite() {
    return true;
  }
  
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps,list);
    nombreTermes = new CValeurAssocieeAVariable();
    if (nVersion == 1) {
      int nbtermes = inps.readCInt();
      nombreTermes.donneValeur(nbtermes);
    }
    else nombreTermes.chargeDepuisFlux(inps, list);
    premierTerme = new CValeurAssocieeComp();
    premierTerme.chargeDepuisFlux(inps, list);
    int ind1 = inps.readCInt();
    fonctionAssociee = (CFoncComplexe) (list.get(ind1,CFoncComplexe.class));
    // metAJourNombreTermes();
    // Le nombre de valeurs tant dynamique, on ne peut pas le connatre au chargement
    // On met 1 terme arbitrairement et cela sera rectifi dans positionne();
    nbt = 1;
    valeurs = new Complexe[nbt];
    nVersion = numeroVersion(); // On remet tout  zro pour la version java
  }
  /* Lecture depuis dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    nombreTermes = new CValeurAssocieeAVariable();
    nombreTermes.read(inps, list);
    premierTerme = new CValeurAssocieeComp();
    premierTerme.read(inps, list);
    int ind1 = inps.readInt();
    fonctionAssociee = (CFoncComplexe) (list.get(ind1,CFoncComplexe.class));
    // metAJourNombreTermes();
    // Le nombre de valeurs tant dynamique, on ne peut pas le connatre au chargement
    // On met 1 terme arbitrairement et cela sera rectifi dans positionne();
    nbt = 1;
    valeurs = new Complexe[nbt];
  }
  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    nombreTermes.write(oups, list);
    premierTerme.write(oups, list);
    int ind1 = list.indexOf(fonctionAssociee);
    oups.writeInt(ind1);
  }
  
  @Override
  public long getNatureCalcul() {
  	return NatureCalcul.NSuiteRecurrenteComplexe;
  }
  
}
