/*
 * CSurfaceSecteurCirculaire.java
 *
 * Created on 18 juillet 2004, 18:16
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import glob.*;

import java.awt.*;

import types.*;


public class CSurfaceSecteurCirculaire extends CSurface {

  /** Creates new CSurfaceSecteurCirculaire */
  public CSurfaceSecteurCirculaire() {
  }
  
  // Constructeur pour clonage
   public CSurfaceSecteurCirculaire(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
        Color couleurInit, boolean masqueInit, int styleRemplissageInit, CArcDeCercleAncetre bordInit) {
     super(liste, impProtoInit, estElementFinalInit, couleurInit, masqueInit, styleRemplissageInit, bordInit);
   }

  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(bord);
    int ind2 = listeSource.indexOf(impProto);        
    CElementBase ptelb = new CSurfaceSecteurCirculaire(listeCible, (CImplementationProto)(listeCible.get(ind2, CImplementationProto.class)),
      estElementFinal, couleur, masque, styleRemplissage, (CArcDeCercleAncetre)(listeCible.get(ind1, CArcDeCercleAncetre.class)));
    return ptelb;
  }
    
  @Override
  public void trace(Graphics2D pDC, Color couleurFond, float transparence) {
    int styleRemplissageEffectif;
    if (masque) styleRemplissageEffectif = StyleRemplissage.QuadrillageCroise;
    else styleRemplissageEffectif = styleRemplissage;
    if (styleRemplissageEffectif == StyleRemplissage.QuadrillagePleinTransp) {
    	if (transparence != 1) {
    		pDC.setColor(couleur);
  	    Composite originalComposite = pDC.getComposite();
  	    pDC.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, transparence));
  	    dessine(pDC);
  	    pDC.setComposite(originalComposite);    		
    	}
    	else {
    		pDC.setColor(couleur);
  	    dessine(pDC);
    	}
    }
    else {
      if (styleRemplissageEffectif == StyleRemplissage.QuadrillagePlein) {
    		pDC.setColor(couleur);
  	    dessine(pDC);
      }
      else {
	    	TexturePaint tp = StyleRemplissage.getTexturePaint(couleur, styleRemplissageEffectif, listeProprietaire.basseDefinition, couleurFond);
	    	pDC.setPaint(tp);
		    dessine(pDC);
      }
    }
  }
  
  private void dessine(Graphics2D pDC) {
    CArcDeCercleAncetre ptc = (CArcDeCercleAncetre) bord;
    switch (ptc.natureArc()) {   
      case NatureArc.NatureArcPetitArc :
        Kernel.secteurSaillantPlein(pDC, ptc.origine_x, ptc.origine_y, ptc.centre_x, ptc.centre_y,
          ptc.rayon, ptc.valeurAngleAuCentre);
        break;
      case NatureArc.NatureArcGrandArc :
        Kernel.secteurRentrantPlein(pDC, ptc.origine_x, ptc.origine_y, ptc.centre_x, ptc.centre_y,
        ptc.rayon, ptc.valeurAngleAuCentre);
        break;
      case NatureArc.NatureArcArcDirect :
        Kernel.secteurDirectPlein(pDC, ptc.origine_x, ptc.origine_y, ptc.centre_x, ptc.centre_y,
        ptc.rayon, ptc.valeurAngleAuCentre);
        break;
      case NatureArc.NatureArcArcIndirect :
        VecteurDirecteur u = new VecteurDirecteur(ptc.centre_x, ptc.centre_y, ptc.origine_x,
          ptc.origine_y);
        VecteurDirecteur v = new VecteurDirecteur();
        u.tourne(ptc.valeurAngleAuCentre, v);
        double x1 =ptc.centre_x + v.x;
        double y1 = ptc.centre_y + v.y;
        Kernel.secteurDirectPlein(pDC, x1, y1, ptc.centre_x, ptc.centre_y, ptc.rayon,
          -ptc.valeurAngleAuCentre);
    }  	
  }
}
