/*
 * CVecteur.java
 *
 * Created on 6 juillet 2004, 09:00
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import java.awt.*;
import java.io.*;

import types.*;

import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

public class CVecteur extends CSegment {
  public int motifFleche;
  public double xa,xb,ya,yb;
  /** Creates new CVecteur */
  public CVecteur() {
  }
  
  // Constructeur pour clonage
  public CVecteur(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
      Color couleurInit, boolean masqueInit, int styleInit,
      CPointAncetre point1Init, CPointAncetre point2Init, int motifFlecheInit) {
    super (liste, impProtoInit, estElementFinalInit, couleurInit, masqueInit, styleInit, point1Init, point2Init);
    motifFleche = motifFlecheInit;
  }

  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(impProto);
    int ind2 = listeSource.indexOf(point1);
    int ind3 = listeSource.indexOf(point2);
    CElementBase ptelb = new CVecteur(listeCible, (CImplementationProto)(listeCible.get(ind1, CImplementationProto.class)),
      estElementFinal, couleur, masque, style, (CPointAncetre) listeCible.get(ind2, CPointAncetre.class),
      (CPointAncetre) listeCible.get(ind3, CPointAncetre.class), motifFleche);
    return ptelb;
  }
  
  @Override
  public String complementInfo() {
    return textes.Chaines.chinfo155;
  }
  
  @Override
  public String infoPourHistorique() {
    return textes.Chaines.chinfo154;
  }
  
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    super.positionne(infoRandom, dimfen);
    xa = point1.x;
    ya = point1.y;
    xb = point2.x;
    yb = point2.y;   
  }
  
  @Override
  /**
   * A t modifi par rapport au C++
   */
	public boolean confonduAvec(CElementBase p) {
    CVecteur pt;
    if (p.getClass() == this.getClass()) {
      pt = (CVecteur) p;
  		return 
			(point1 == pt.point1) && (point2 == pt.point2);
   }
    else return false;
	}
  
  @Override
  public void setClone(CElementBase ptel) {
    super.setClone(ptel);
    xa = ((CVecteur)ptel).xa;  
    ya = ((CVecteur)ptel).ya;  
    xb = ((CVecteur)ptel).xb;  
    yb = ((CVecteur)ptel).yb;
  }
  @Override
  public void trace(Graphics2D pDC, Color couleurFond, float transparence) {
    boolean basseDefinition = listeProprietaire.basseDefinition;
    if (!(point1.horsEcran) && !(point2.horsEcran) && vecteur.nonNul())
    {
      super.trace(pDC, couleurFond, transparence);
      int styleTrait;
      if (masque) styleTrait = StyleTrait.traitPointille;
      else styleTrait = style;
      pDC.setStroke(Pinceau.CreePinceau(styleTrait));
      pDC.setColor(couleur);
      // On ne trace la flche que si le vecteur n'est pas presque nul
      if (!vecteur.presqueNul()) StyleFleche.traceFleche(pDC,xa,ya,xb,yb,motifFleche, basseDefinition);
    }
  }
  
  @Override
  public long getNature() {
    return NatureObjet.NVecteur;
  }
  
  @Override
  public String chaineDesignation() {
    return textes.Chaines.designationVecteur;
  }
  
  public void donneStyleFleche(int styleFleche) {
  	motifFleche = styleFleche;
  }
  
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    motifFleche = inps.readByte();
  }
  /* Lecture depuis dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    motifFleche = inps.readByte();
  }
  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    oups.writeByte(motifFleche);
  }  
}
