/*
 * OutilMed.java
 *
 * Created on 4 mars 2006, 18:30
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package outils;

import objets.*;
import types.*;
import Applet.*;

/**
 *
 * @author Yves
 */
public class OutilMed extends OutilPar2pts {
  
  /** Creates a new instance of OutilMed */
  public OutilMed(AppletMathGraph32 appletMereInit) {
    super(appletMereInit);
  }
  
  public int idMenu() {
    return 32790;
  }
  
  /**
   * Renvoie le nom du fichier gif associ  l'outil
   * @return
   */
  public String nomGif() {
    return "DteMed.gif";
  }
  
  public String chaineInfo() {
    return textes.Chaines.chaineInfo12;
  }  
 
  public String toolTip() {
    return textes.Chaines.toolTip12;
  }
  
  /* Appel pour crer finalement l'objet une fois que tous les objets dont il
   * dpend ont t dsigns */
  public void creeObjet() {
    CMediatrice pt = new CMediatrice(appletMere.listePr, null, false,
      appletMere.couleurActive(), StyleTrait.traitFin, point1, point2, 2);
    if (appletMere.ajouteElementAvecVerification(pt))
      appletMere.gestionnaire.enregistreFigureEnCours(textes.Chaines.chaineOutil11);
    annuleClignotement();
    select();
  }
  /* Mthode ajoutant les objets visuels  la liste listeObjetsVisuels de l'applet
   * au fur et  mesure que l'on dsigne les obejts  la souris
   * Doit tre redfini pour chaque outil utilisant une aide visuelle  la cration
   */
  public void ajouteObjetsVisuels() {
    CListeObjets liste = appletMere.listeObjetsVisuels;
    CMilieu ptm = new CMilieu(liste, null, false, Couleur.TraduitCouleur(1), MotifPoint.petitRond,
      point1, appletMere.pointSouris);
    ptm.cache();
    liste.add(ptm);
  	// On cre deux segments en pointills
  	CSegment pts1 = new CSegment(liste, null, false, point1, ptm);
    liste.add(pts1);
  	CSegment pts2 = new CSegment(liste, null, false, ptm, appletMere.pointSouris);
    liste.add(pts2);
    // On cre une marque de segment pour les deux
    CMarqueSegment ptMarque1 = new CMarqueSegment(liste, null, false,
      Couleur.TraduitCouleur(1), false, StyleTrait.traitEpais,
      MotifMarqueSegment.MarqueSimple, pts1);
    liste.add(ptMarque1); 
    CMarqueSegment ptMarque2 = new CMarqueSegment(liste, null, false,
       Couleur.TraduitCouleur(1), false, StyleTrait.traitEpais,
      MotifMarqueSegment.MarqueSimple, pts2);
    liste.add(ptMarque2);
    // On cre une perpendiculaire plutt qu'une mdiatrice pour pouvoir lui adjoindre
    // une marque d'angle droit
    CDroitePerpendiculaire ptPer = new CDroitePerpendiculaire(liste, null, false,
      Couleur.TraduitCouleur(1), StyleTrait.traitPointille, ptm, pts1, 2);
    appletMere.listeObjetsVisuels.add(ptPer);
    // Cration de la marque d'angle droit
    CMarqueAngleDroit marque = new CMarqueAngleDroit(liste, null, false, ptPer);
    appletMere.listeObjetsVisuels.add(marque);
  }
  public String chaineIndication (int indEtape) {
    switch(indEtape) {
      case 1 : return textes.Chaines.mediatrice1;
      case 2 : return textes.Chaines.mediatrice2;
      default: return "";
    }
  }
}
