/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package outils;

import Applet.AppletMathGraph32;
import java.awt.Color;
import objets.*;
import types.Couleur;
import types.MotifPoint;
import types.StyleEncadrement;
import types.StyleMarqueAngle;
import types.StyleTrait;
import types.VecteurDirecteur;

/**
 *
 * @author Yves
 */
public class OutilMesAngNor extends OutilPar3pts {

  /** Creates a new instance of OutilSeg */
  public OutilMesAngNor(AppletMathGraph32 appletMereInit) {
    super(appletMereInit);
  }

  /**
   * Les outils descendant de OutilPar2Pts et necessitant que les points dsigns
   * soient nomms s'ils n'ont pas de noms devront redfinir cette fonction en renvoyant true
   * Cela servira pour l'outil de mesure de longueur
   * @return true si les points dsigns doivent tre nomms
   */
  boolean nomsPointsIndisp() {
    return true;
  }
  
  public int idMenu() {
    return 32816;
  }
  
  /**
   * Renvoie le nom du fichier gif associ  l'outil
   * @return
   */
  public String nomGif() {
    return "MesAngNor.gif";
  }
  
  public String chaineInfo() {
    return textes.Chaines.chaineInfo29;
  }

  public String toolTip() {
    return textes.Chaines.toolTip29;
  }
  
  /* Appel pour crer finalement l'objet une fois que tous les objets dont il
   * dpend ont t dsigns */
  public void creeObjet() {
    appletMere.videDesignation();
    CMesureAngleGeometrique mes = new CMesureAngleGeometrique
            (appletMere.listePr, null, false , point1, point2, point3);
    if (appletMere.ajouteElementAvecVerification(mes)) {
      objetCree = true; // Necessaire  cause du fait que point1 et point2 ont t ventuellement
      appletMere.gestionnaire.enregistreFigureEnCours(textes.Chaines.chaineOutil25);
      appletMere.dialogueAvertissement(textes.Chaines.ch27 + " " + mes.nom() + " " +  textes.Chaines.ch28);
    }
    annuleClignotement();
    appletMere.activeOutilCapture();
  }

  /** Mthode ajoutant les objets visuels  la liste listeObjetsVisuels de l'applet
   * au fur et  mesure que l'on dsigne les obejts  la souris
   * Doit tre redfini pour chaque outil utilisant une aide visuelle  la cration
   */
  @Override
  public void ajouteObjetsVisuels() {    
    CListeObjets list = appletMere.listeObjetsVisuels;
    // On cre deux segments en pointills
  	CSegment pts1 = new CSegment(list, null, false, point1, point2);
  	appletMere.ajouteObjetVisuel(pts1);
  	CSegment pts2 = new CSegment(list, null, false, point2, appletMere.pointSouris);
  	appletMere.ajouteObjetVisuel(pts2);
    // On cre une marque d'angle non  orient
    CMarqueAngleGeometrique mar = new CMarqueAngleGeometrique(list, null, false,
            Color.BLACK, false, StyleTrait.traitEpais, StyleMarqueAngle.marqueSimple, 12, point1, point2, appletMere.pointSouris);
    appletMere.ajouteObjetVisuel(mar);
    // On cre un point par abscisse sur le segment joignant point2 et point1 
    // une distance de 20 pixels de point2
    VecteurDirecteur vec = new VecteurDirecteur(point2, point1);
    double d = 20/vec.norme();
    CValeurAssocieeAVariable ab = new CValeurAssocieeAVariable(list, d);
    CPointParAbscisse pt1 = new CPointParAbscisse(list, null, false, Color.BLACK, 
            false, 0d, 0d, true, "", 2, MotifPoint.croix, point2, point1, ab);
    appletMere.ajouteObjetVisuel(pt1);
    // On cre un petit arc de cercle de centre point2, commenant par point 1
    // et dirig vers le pointeur souris
    CArcDeCercle arc = new CArcDeCercle(list, null, false, Color.BLACK,
            true, StyleTrait.traitFin, point2, pt1, appletMere.pointSouris, null);
    appletMere.ajouteObjetVisuel(arc);
    // On cre une bissectrice
    CBissectrice bis = new CBissectrice(list, null, false, Color.BLACK, StyleTrait.traitFin,
            point1, point2, appletMere.pointSouris, 2);
    bis.cache();
    appletMere.ajouteObjetVisuel(bis);
    // On cre l'intersection de l'arc et de la bissectrice
    CIntDroiteCercle inter = new CIntDroiteCercle(list, null, false, bis, arc);
    appletMere.ajouteObjetVisuel(inter);
    CPointLieBipoint ptl1 = new CPointLieBipoint(list, null, false, Color.BLACK,
            false, 0d, 0d, true, "", 2, MotifPoint.croix, inter, 1);
    appletMere.ajouteObjetVisuel(ptl1);
    CPointLieBipoint ptl2 = new CPointLieBipoint(list, null, false, Color.BLACK,
            false, 0d, 0d, true, "", 2, MotifPoint.croix, inter, 2);
    appletMere.ajouteObjetVisuel(ptl2);
    // Un des deux points d'intersection n'existera pas mais on ne sait pas lequel
    // On cre un commentaire contenant un point d'intersection li  chacun d'eux
    CCommentaire com1 = new CCommentaire(list, null, false, Color.BLACK, 0d, 0d,
                -4d, -6d, false, ptl1, 1, StyleEncadrement.Sans, false, Couleur.TraduitCouleur(0), "?");
    appletMere.ajouteObjetVisuel(com1);
    CCommentaire com2 = new CCommentaire(list, null, false, Color.BLACK, 0d, 0d,
                -4d, -6d, false, ptl2, 1, StyleEncadrement.Sans, false, Couleur.TraduitCouleur(0), "?");
    appletMere.ajouteObjetVisuel(com2);
  }
/**
   * Fonction renvoyant la chane  afficher  l'tape i (i >= 1) comme indication
   * Doit tre redfinie par les descendants devant crire plusieurs indications
   * @param i : l'indice
   * @return
   */          
  public String chaineIndication (int indEtape) {
    switch(indEtape) {
      case 1 : return textes.Chaines.mesAngNor1;
      case 2 : return textes.Chaines.mesAngNor2;
      case 3 : return textes.Chaines.mesAngNor3;
      
      default: return "";
    }
  }
}  
