/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package outils;

import Applet.AppletMathGraph32;
import java.awt.Color;
import objets.*;
import types.Couleur;
import types.MotifPoint;
import types.StyleEncadrement;
import types.StyleFleche;
import types.StyleTrait;

/**
 *
 * @author Yves
 */
public class OutilMesLong extends OutilPar2pts{

  /** Creates a new instance of OutilSeg */
  public OutilMesLong(AppletMathGraph32 appletMereInit) {
    super(appletMereInit);
  }

  /**
   * Les outils descendant de OutilPar2Pts et necessitant que les points dsigns
   * soeint nomms s'ils n'ont pas de noms devront redfinir cette fonction en renvoyant true
   * Cela servira pour l'outil de mesure de longueur
   * @return true si les points dsigns doivent tre nomms
   */
  boolean nomsPointsIndisp() {
    return true;
  }
  
  public int idMenu() {
    return 32813;
  }
  
  /**
   * Renvoie le nom du fichier gif associ  l'outil
   * @return
   */
  public String nomGif() {
    return "MesLong.gif";
  }
  
  public String chaineInfo() {
    return textes.Chaines.chaineInfo28;
  }
  
  public String toolTip() {
    return textes.Chaines.toolTip28;
  }
  
  /* Appel pour crer finalement l'objet une fois que tous les objets dont il
   * dpend ont t dsigns */
  public void creeObjet() {
    appletMere.videDesignation();
    CLongueur lon = new CLongueur(appletMere.listePr, null, false , point1, point2);
    if (appletMere.ajouteElementAvecVerification(lon)) {
      objetCree = true; // Necessaire  cause du fait que point1 et point2 ont t ventuellement
      // nomms et que si on ne cre pas l'objet on remet alors leur nom  une chaine vide
      appletMere.gestionnaire.enregistreFigureEnCours(textes.Chaines.chaineOutil23);
      appletMere.dialogueAvertissement(textes.Chaines.ch25 + " " + lon.nom() + " " + textes.Chaines.ch26);
    }
    annuleClignotement();
    appletMere.activeOutilCapture();
  }
  
  /** Mthode ajoutant les objets visuels  la liste listeObjetsVisuels de l'applet
   * au fur et  mesure que l'on dsigne les obejts  la souris
   * Doit tre redfini pour chaque outil utilisant une aide visuelle  la cration
   */
  public void ajouteObjetsVisuels() {
    CListeObjets list = appletMere.listeObjetsVisuels;
    // On cre deux vecteurs provisoires pour avoir une double flche
    CVecteur v1 = new CVecteur(list, null, false,
            appletMere.couleurActive(), false, StyleTrait.traitPointille,
            point1, appletMere.pointSouris, StyleFleche.FlecheLonguePleine);
    appletMere.listeObjetsVisuels.add(v1);
    CVecteur v2 = new CVecteur(list, null, false,
            appletMere.couleurActive(), false, StyleTrait.traitPointille,
            appletMere.pointSouris, point1, StyleFleche.FlecheLonguePleine);
    appletMere.listeObjetsVisuels.add(v2);
    // On cre le milieu pour lui lier un point d'interrogation     
    CMilieu mil = new CMilieu(list, null, false, Color.BLACK,
            MotifPoint.croix, appletMere.pointSouris, point1);
    mil.cache();
    appletMere.listeObjetsVisuels.add(mil);
    // On cre un commentaire contenant comme texte un point d'interrogation
    CCommentaire com = new CCommentaire(list, null, false, Color.BLACK, 0d,0d,
                -8d, -2d, false, mil, 1, StyleEncadrement.Sans, false, Couleur.TraduitCouleur(0), "?");
    appletMere.listeObjetsVisuels.add(com);
  }
  
  /**
   * Fonction renvoyant la chane  afficher  l'tape i (i >= 1) comme indication
   * Doit tre redfinie par les descendants devant crire plusieurs indications
   * @param i : l'indice
   * @return
   */          
  public String chaineIndication (int indEtape) {
    switch(indEtape) {
      case 1 : return textes.Chaines.mesLong1;
      case 2 : return textes.Chaines.mesLong2;
      default: return "";
    }
  }  
}
