/*
 * OutilMilieu.java
 *
 * Created on 2 aot 2006, 19:56
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package outils;

import objets.*;
import types.*;
import Applet.*;


/**
 *
 * @author Yves
 */
public class OutilMilieu extends OutilPar2pts {
  
  /** Creates a new instance of OutilMilieu */
  public OutilMilieu(AppletMathGraph32 appletMereInit) {
    super(appletMereInit);
  }
  
  public int idMenu() {
    return 32781;
  }
 
  /**
   * Renvoie le nom du fichier gif associ  l'outil
   * @return
   */
  public String nomGif() {
    return "Milieu.gif";
  }
  
  public String chaineInfo() {
    return textes.Chaines.chaineInfo13;
  }  
  
  public String toolTip() {
    return textes.Chaines.toolTip13;
  }

  /* Appel pour crer finalement l'objet une fois que tous les objets dont il
   * dpend ont t dsigns */
  public void creeObjet() {
    CMilieu pt = new CMilieu(appletMere.listePr, null, false,
      appletMere.couleurActive(), MotifPoint.croix, point1, point2);   
    if (appletMere.ajouteElementAvecVerification(pt))
      appletMere.gestionnaire.enregistreFigureEnCours(textes.Chaines.chaineOutil12);
    annuleClignotement();
    select();
  }
  
  /* Mthode ajoutant les objets visuels  la liste listeObjetsVisuels de l'applet
   * au fur et  mesure que l'on dsigne les obejts  la souris
   * Doit tre redfini pour chaque outil utilisant une aide visuelle  la cration
   */
  public void ajouteObjetsVisuels() {
    CListeObjets liste = appletMere.listeObjetsVisuels;
    CMilieu ptm = new CMilieu(liste, null, false, Couleur.TraduitCouleur(1),
      MotifPoint.petitRond, point1, appletMere.pointSouris);
    liste.add(ptm);
  	// On cre deux segments en pointills
  	CSegment pts1 = new CSegment(liste, null, false, point1, ptm);
    liste.add(pts1);
  	CSegment pts2 = new CSegment(liste, null, false, ptm, appletMere.pointSouris);
    liste.add(pts2);
    // On cre une marque de segment pour les deux
    CMarqueSegment ptMarque1 = new CMarqueSegment(liste, null, false,
      Couleur.TraduitCouleur(1), false, StyleTrait.traitEpais,
      MotifMarqueSegment.MarqueSimple, pts1);
    liste.add(ptMarque1); 
    CMarqueSegment ptMarque2 = new CMarqueSegment(liste, null, false,
      Couleur.TraduitCouleur(1), false, StyleTrait.traitEpais,
      MotifMarqueSegment.MarqueSimple, pts2);
    liste.add(ptMarque2);
  }  
  public String chaineIndication (int indEtape) {
    switch(indEtape) {
      case 1 : return textes.Chaines.milieu1;
      case 2 : return textes.Chaines.milieu2;
      default: return "";
    }
  }
}
