/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import Applet.AppletMathGraph32;
import objets.CListeObjets;
import objets.CPointDansRepere;
import objets.CValeurAssocieeAVariable;
import types.MotifPoint;
import types.NatureCalcul;
import types.NatureObjet;
import dialogs.CoordonneesDlg;


@SuppressWarnings("unused")
public class OutilPointParCoordonnees extends Outil {
  public OutilPointParCoordonnees(AppletMathGraph32 appletInit) {
    super(appletInit, false, AppletMathGraph32.iconCreerPointParCoordonnees);
  }
  
  public int idMenu() {
    return 32782;
  }
  
  public String toolTip() {
    return getString("toolTip35");
  }  
  
  @Override
	public boolean activationValide() {
		return appletMere.listePr.nombreObjetsParNatureCalculNonIntermediaires(NatureCalcul.NRepere)>0;
	}
	  
  @Override
  public void select() {
    super.select();
    appletMere.indication("");
    CListeObjets liste = appletMere.listePr;
    
    CPointDansRepere point = new CPointDansRepere(appletMere.listePr, null, false, appletMere.couleurActive(),
    		false, 0d, 0d, false, "", 2, MotifPoint.petitRond, null, new CValeurAssocieeAVariable(liste, 1d),
    		new CValeurAssocieeAVariable(liste, 1d), false);
    CoordonneesDlg dlg = new CoordonneesDlg(appletMere, point, false);
    dlg.setVisible(true);
    if (dlg.retourOK()) {
      if (appletMere.ajouteElementAvecVerification(point)) {
        appletMere.gestionnaire.enregistreFigureEnCours(getString("chaineOutil41"));
        appletMere.repaintFigureAvecCalcul();
      }
    }
    appletMere.activeOutilCapture();
    point = null;
  } 
}
