/**
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 *
 * @author Yves
 * Objet servant  traiter les clics de souris sur la figure
 */
package outils;

import java.awt.*;

import objets.CMathGrafDoc;
import types.DimensionFenetre;
import Applet.*;

public class OutilPointage {
  AppletMathGraph32 appletMere;
  Cursor curseurActif; // Le curseur utilis par cet outil
  // Nouveau version 2.0 : Mis  true si dans paint de MtgFigurePanel.paint on doit redessiner la figure
  public boolean aRedessinerDansPaint;
  long aDesigner;  // Nature des objets  dsigner pour l'outil de pointage
  // pour cration d'objets
  public long naturePointCapture; // Nature du point proche du pointeur souris
  // Sera null  l'activation de l'outil;
 
  /** Creates a new instance of OutilPointage */
  public OutilPointage(AppletMathGraph32 appletMereInit) {
    appletMere = appletMereInit;
    aRedessinerDansPaint = false;
  }
  
  public static final String getString(String key) {
  	return AppletMathGraph32.getString(key);
  }
  
  
  public void reset() {
    aRedessinerDansPaint = true;
  }
  /**
   * Version 2.0 :  redfinir pour les descendants
   * Ce qu'il faut faire dans paint pour rpondre aux actions de la souris
   */
  public void actionDansPaint(AppletMathGraph32 applet) {
  	if (applet.listeClignotante.size() == 0) return;
  	Graphics2D gbuffer = applet.paneFigure.gbuffer;
  	DimensionFenetre dimf = applet.dimf;
		CMathGrafDoc doc= applet.document;
		MtgPaneFigure paneFigure = applet.paneFigure;
		paneFigure.effacegBuffer();
		Outil outilActif = applet.outilActif;
		if (outilActif.timer != null) {
    	if (outilActif.nbClignPair) {
    		// Ncessaire de ne pas afficher deux fois les mmes pour les affichages de surface avec transparence
    		// donc ne pas afficher les lemnts de listeClignotante (qui peuvent tre des objest provisoires
    		applet.listePr.afficheToutSaufElementsDe(gbuffer, dimf, true, doc.couleurFond,
    			doc.transparencePourSurfaces, applet.listeClignotante, appletMere.pref_antialiasing);
    		applet.listeClignotante.afficheTout(gbuffer, dimf, true, doc.couleurFond,
    			doc.transparencePourSurfaces, appletMere.pref_antialiasing);
    	}
    	else applet.listePr.afficheToutSaufElementsDe(gbuffer, dimf, true, doc.couleurFond,
    			doc.transparencePourSurfaces, applet.listeClignotante, applet.pref_antialiasing);
		}
		else paneFigure.afficheToutDansgbuffer();
		aRedessinerDansPaint = false;
  }
  
  public void setActiveCursor(Cursor cursor) {
    curseurActif = cursor;
  }

  public void mouseClicked(java.awt.event.MouseEvent mouseEvent) {
  }
  public void mouseMoved(java.awt.event.MouseEvent mouseEvent) {
  	
  }
  public void mouseDragged(java.awt.event.MouseEvent mouseEvent) {
  }  
  public void mousePressed(java.awt.event.MouseEvent mouseEvent) {
  }
  public void mouseReleased(java.awt.event.MouseEvent mouseEvent) {
  }
}
