/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package outils;
import Applet.*;
import java.awt.Color;
import java.awt.Point;
import javax.swing.BorderFactory;
import objets.*;
import types.FonteNom;

/**
 * Outil permettant  l'utilisateur de cliquer sur des objets pour proposer sa solution
 * @author Yves
 */
public class OutilPropSol extends Outil {
  int indiceObjetEnCours;
  /**
   * Constructeur
   * @param appletMereInit
   */
  public OutilPropSol(AppletMathGraph32 appletMereInit) {
    super(appletMereInit, true);
  }
  /**
   * @return Renvoie le nom du fichier gif associ  l'outil
   */
  public String nomGif() {
    return "Solution.gif";
  }
  public String chaineInfo() {
    return textes.Chaines.chaineInfo24;
  }
  
  public String toolTip() {
    return textes.Chaines.toolTip24;
  }
  
  public String chaineIndication (int indEtape) {
    return textes.Chaines.ch8 + appletMere.indicationSol(indEtape);
  }
  
    /** Appel lorsque l'outil est slectionn */
  public void select() {
    super.select();
    indiceObjetEnCours = 1;
    appletMere.annuleSolutionProposee();
    CElementBase elb =(CElementBase) appletMere.listeAConstruire.get(0);
    appletMere.outilPointageActif = appletMere.outilPointagePropSol;
    appletMere.outilPointageActif.reset();
    designationDe(elb.naturePourConst());
    appletMere.indication(chaineIndication(1));
  }
  /* Appel lorsqu'un objet a t cliqu pour tre trait par l'outil
   * par exemple le premier point pour crer une droite passant par deux points */
  public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
    appletMere.listeProposee.add(elg);
    ajouteClignotementDe(elg);
    resetClignotement();
    indiceObjetEnCours++;
    if (indiceObjetEnCours <= appletMere.listeAConstruire.size()) {
      CElementBase elb =(CElementBase) appletMere.listeAConstruire.get(indiceObjetEnCours-1);
      designationDe(elb.getNature());
      appletMere.indication(chaineIndication(indiceObjetEnCours));
   }
    else creeObjet();
  }
  /* On va maintenant regarder si les objets cliqus sont les bons */
  public void creeObjet() {
    appletMere.constructionExacte = appletMere.reponseValide();
    annuleClignotement();
    appletMere.activeOutilCapture();
    appletMere.indication(textes.Chaines.validationSol);
  }
  
  /**
   * 
   * @return Renvoie un pointeur sur le bouton correspondant  l'outil cr
   * ou null si l'outil est interdit pour la figure
   * Est redfini pour cet outil car il n'est pas dfini  partir d'un gif
   */
  @Override
  public JMtgButton boutonAssocie() {
    // Si l'item de l'outil est 0, c'est que le bouton correspondant
    // doit figurer toujours dans la barre d'outils
    int id = idMenu();
    CMathGrafDoc doc = appletMere.document;
    boolean b = doc.itemContenu(id);
    if ((id == 0) 
           || (!doc.itemsCochesInterdits && b)
           || (doc.itemsCochesInterdits && !b)) {
      JMtgButton button = new JMtgButton(textes.Chaines.solution, this);
      button.setBorder(BorderFactory.createEmptyBorder(2, 4, 2, 4));
      button.setForeground(Color.red);
      button.setFont(FonteNom.getFonteNom(3, FonteNom.Gras, true));      
      button.setToolTipText(toolTip());
      button.addActionListener(appletMere);
      button.addMouseListener(appletMere);
      return button;
    }
    else return null;
  }
  
}