package types;
/*
 * FonteNoms.java
 *
 * Created on 17 juin 2004, 16:59
 */

/**
 *
 * @author  Yves
 * @version 
 */
import java.awt.*;
// Classe qui par ses mthodes de classe perlet de grer es fontes de caractres//
public class FonteNom {
  static final public int Normal   = 0;
  static final public int Gras   = 1;
  static final public int Italique   = 2;

  /** Creates new FonteNoms */
    public FonteNom() {
    }
   // Mthode renvoyant la taille de caractres correspondant  l'indice de taille Indicede Taille//
    public static final int taille(int indiceDeTaille, boolean basseResolution) {
    	if (basseResolution) {
	      switch (indiceDeTaille)
	      {
	        case 0 :
	          return 11;
	        case 1 :
	          return 12;
	        case 2 :
	          return 13;
	        case 3 :
	          return 14;
	        case 4 :
	          return 17;
	        case 5 :
	          return 19;
	        default : return 13;
	      }
    	}
    	else {
	      switch (indiceDeTaille)
	      {
	        case 0 :
	          return 110;
	        case 1 :
	          return 120;
	        case 2 :
	          return 130;
	        case 3 :
	          return 140;
	        case 4 :
	          return 170;
	        case 5 :
	          return 190;
	        default : return 120;
	      }    		
    	}
    }
    
    // Modification de la version java : on accepte les lettres grecques
  public static final boolean lettre(char car) {
    boolean res = ((car  >= 'a') && (car <= 'z')) || ((car >= 'A') && (car <= 'Z'));
    // Lettres grecques acceptes par le logiciel
    res = res || ((car >= 0x3b1) && (car <= (0x3b1 + 7)));
    res = res || (car == 0x3b1 + 10);
    res = res || (car == 0x3b1 + 11);
    res = res || (car == 0x3b1 + 13);
    res = res || ((car >= 0x3b1 + 15) && (car <= (0x3b1 + 19)));
    res = res || ((car >= 0x3b1 + 21) && (car <= (0x3b1 + 24)));
    res = res || ((car >= 0x391 + 2) && (car <= (0x391 + 3)));
    res = res || (car == 0x391 + 15);
    res = res || ((car >= 0x391 + 18) && (car <= (0x391 + 19)));
    res = res || ((car >= 0x391 + 21) && (car <= (0x391 + 24)));
    return res;
  }

  public static final boolean prime(char car) {
    return (car == '\'') || (car == '"');
  }
  public static final boolean chiffre(char car) {
    return (car >= '0') && (car <= '9');
  }
  
  // Mthode de classe renvoyant une fonte de la taille voulue //
  public static final Font getFonteNom(int indiceTailleNom, int styleFonte, boolean basseResolution ) {
    switch (styleFonte) {
      case Normal :
        return new Font("Serif", Font.PLAIN, taille(indiceTailleNom, basseResolution));
      case Gras :
        return new Font("Serif", Font.BOLD, taille(indiceTailleNom, basseResolution));
      case Italique :
      default :
        return new Font("Serif", Font.ITALIC, taille(indiceTailleNom, basseResolution));
    }
  }
  
  public final static String premiersCaracteresNonChiffres(String ch) {
  	int len = ch.length();
  	int i = 0;
  	while (i < len) {
  		if (chiffre(ch.charAt(i))) break;
  		else i++;
  	}
  	if (i == len) return ch;
  	else return ch.substring(0, i);
  }
  
  // Nouveauts pour la version 1.8
  // Fonction renvoyant une taille de police infrieure  celle de IndiceTaille
  // pour crire en exposant ou en indice
   public static final int indiceTaillePourExposantOuIndice(int indiceTaille)
  {
    switch (indiceTaille)
    {
        case 0 : // Taille 8
          return 0;
        case 1 : // Taille 9
          return 0;
        case 2 : // Taille 11
          return 0;
        case 3 : // Taille 12
          return 1;
        case 4: // Taille 14
          return 2;
        case 5 : // Taille 16
        default :
          return 2;
    }
  }
  // Nouveauts pour la version 1.8
  // Fonction renvoyant le dcalage en hauteur ou vers le bas lorsqu'on crit un exposant
  // ou un indice suivant l'indice de la taille de la police utilise
  // Dcalages augments par rapport au C++
  public static final int decalageLogiquePourExposantOuIndice(int indiceTaille, boolean basseResolution)
  {
  	if (basseResolution) {
	    switch (indiceTaille)
	    {
        case 0 : // Taille 8
          return 3;
        case 1 : // Taille 9
          return 3;
        case 2 : // Taille 11
          return 3;
        case 3 : // Taille 12
          return 4;
        case 4: // Taille 14
          return 4;
        case 5 : // Taille 16
        default :
          return 3;
	    }
  	}
  	else {
	    switch (indiceTaille)
	    {
        case 0 : // Taille 8
          return 30;
        case 1 : // Taille 9
          return 30;
        case 2 : // Taille 11
          return 30;
        case 3 : // Taille 12
          return 40;
        case 4: // Taille 14
          return 40;
        case 5 : // Taille 16
        default :
          return 30;
	    }
  		
  	}
  }  
}
