/**
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


package types;
// Dfinit les caractristiques d'un lieu de points
import java.io.*;

import objets.CListeObjets;

import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

// Cette classe a t modifie pour la version 2.5
// en rajoutant un memmre GestionDiscontinuite qui sera true si le lieu
// cre une nouvelle ligne quant la diffrence entre les abscisses ou rodonnes
// entre l'ancienne position et la nouvelle excdent les dimensions de la fentre
public class InfoLieu {
  public int nombreDePoints;
  public boolean fermeOuNon;
  public boolean gestionDiscontinuite;
  
  /** Creates new InfoLieu */
  public InfoLieu() {
  }
  
  public InfoLieu(InfoLieu infoLieuInit) {
    nombreDePoints = infoLieuInit.nombreDePoints;
    fermeOuNon = infoLieuInit.fermeOuNon;
    gestionDiscontinuite = infoLieuInit.gestionDiscontinuite;
  }
  
  public InfoLieu(int nombreDePointsInit, boolean fermeOuNonInit, boolean gestionDiscontinuiteInit) {
  	nombreDePoints = nombreDePointsInit;
  	fermeOuNon = fermeOuNonInit;
  	gestionDiscontinuite = gestionDiscontinuiteInit;
  }
  
  public void setCopy(InfoLieu infoLieuInit) {
    nombreDePoints = infoLieuInit.nombreDePoints;
    fermeOuNon = infoLieuInit.fermeOuNon;
  }
  public void chargeAncienDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    nombreDePoints = inps.readCInt();
    fermeOuNon = inps.readBoolean();
    gestionDiscontinuite = true;
  }
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    nombreDePoints = inps.readCInt();
    fermeOuNon = inps.readBoolean();
    gestionDiscontinuite = inps.readBoolean();
  }
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    nombreDePoints = inps.readInt();
    fermeOuNon = inps.readBoolean();
    gestionDiscontinuite = inps.readBoolean();
  }
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    oups.writeInt(nombreDePoints);
    oups.writeBoolean(fermeOuNon);
    oups.writeBoolean(gestionDiscontinuite);
  }
}
