package types;

// Important : les repres sont considrs aussi comme des objets de type calcul puisqu'on ne peut pas
// les dsigner avec la souris
public class NatureCalcul {
	static final public long NAucunCalcul =							0;
	static final public long NVariable = 								1;
	static final public long NCalculReel = 							1 << 1;
	static final public long NCalculReelConstant = 			1 << 2;	
	static final public long NSuiteRecurrenteReelle =		1 << 3;
	static final public long NSuiteRecurrenteComplexe =	1 << 4;
	static final public long NSolutionEquation = 				1 << 5;
	static final public long NIntegrale	=								1 << 6;
	static final public long NTestExistence =						1 << 7;
	static final public long NSommeIndicee =						1 << 8;
	static final public long NPartieReelle =						1 << 9;
	static final public long NPartieImaginaire =				1 << 10;
	static final public long NModule = 									1 << 11;
	static final public long NArgument = 								1 << 12;
	static final public long NMesureLongueur = 					1 << 13;
	static final public long NMesureAngleNonOriente =		1 << 14;
	static final public long NMesureAngleOriente = 			1 << 15;
	static final public long NMesureAbscisseSurDroite =	1 << 16;
	static final public long NMesureAbscisseRepere =		1 << 17;
	static final public long NMesureOrdonneeRepere =		1 << 18;
	static final public long NMesureLongueurLigne =			1 << 19;
	static final public long NMesureAirePolygone =			1 << 20;
	static final public long NCalculComplexe =					1 << 21;
	static final public long NFonction			 =					1 << 22;
	static final public long NDerivee =									1 << 23;
	static final public long NFonctionComplexe =				1 << 24;
	static final public long NMesureAffixe = 						1 << 25;
	static final public long NRepere =									1 << 26;
	static final public long NMesureCoefDir =						1 << 27;
	static final public long NMesureProduitScalaire = 	1 << 28;
	static final public long NProduitIndice = 					1 << 29;
	
  static public final int nombreTypesObjetsCalcul = 29;
	
	public static final long NFonctionReelle = NFonction | NDerivee;
	public static final long NTouteMesure = NMesureLongueur | NMesureAngleNonOriente | NMesureAngleOriente
		| NMesureAbscisseSurDroite | NMesureAbscisseRepere | NMesureOrdonneeRepere | NMesureLongueurLigne
		| NMesureAirePolygone | NMesureAffixe | NMesureCoefDir | NMesureProduitScalaire;
	
  static final public long NTouteValeurReelle = NVariable | NCalculReel |NCalculReelConstant | NSolutionEquation | NIntegrale
  	| NTestExistence | NSommeIndicee | NProduitIndice | NPartieReelle | NPartieImaginaire | NModule | NArgument | NMesureLongueur
  	| NMesureAngleNonOriente |NMesureAngleOriente | NMesureAbscisseSurDroite | NMesureAbscisseRepere | NMesureOrdonneeRepere
  	| NMesureLongueurLigne | NMesureAirePolygone | NMesureCoefDir | NMesureProduitScalaire;
  static final public long NTouteValeurReelleSaufConst = NVariable | NCalculReel | NSolutionEquation | NIntegrale
  	| NTestExistence | NSommeIndicee | NProduitIndice | NPartieReelle | NPartieImaginaire | NModule | NArgument | NMesureLongueur
  	| NMesureAngleNonOriente |NMesureAngleOriente | NMesureAbscisseSurDroite | NMesureAbscisseRepere | NMesureOrdonneeRepere
  	| NMesureLongueurLigne | NMesureAirePolygone | NMesureCoefDir | NMesureProduitScalaire;
  
  static final public long NTouteValeurComplexe = NCalculComplexe | NMesureAffixe;
  
  static final public long NTouteValeurReelleOuComplexe = NTouteValeurReelle | NTouteValeurComplexe;
  static final public long NTouteValeurReelleOuComplexeSaufConst = NTouteValeurReelleSaufConst | NTouteValeurComplexe;
  static final public long NToutObjetNumeriquePourReclassement = NTouteValeurReelleOuComplexeSaufConst | NFonctionReelle
  | NFonctionComplexe | NSuiteRecurrenteReelle | NSuiteRecurrenteComplexe;
    
  static final public long NTouteValeurPourCommentaireDynamique = NVariable | NCalculReel |NCalculReelConstant | NCalculComplexe
  	| NFonctionReelle | NSolutionEquation | NIntegrale | NTestExistence | NSommeIndicee | NProduitIndice | NPartieReelle
  	| NPartieImaginaire | NModule | NArgument | NMesureLongueurLigne | NMesureAirePolygone | NMesureCoefDir | NMesureProduitScalaire;
  static final public long NFonctionOuSuiteReelle = NFonctionReelle | NSuiteRecurrenteReelle;
  static final public long NFonctionOuSuiteComplexe = NFonctionComplexe | NSuiteRecurrenteComplexe;
  static final public long NCalculOuVariableOuFonctionReelOuComplexe = NVariable | NCalculReel |NCalculReelConstant | NSolutionEquation | NIntegrale
  	| NTestExistence | NSommeIndicee | NProduitIndice | NPartieReelle | NPartieImaginaire | NModule | NArgument | NCalculComplexe
  	| NFonctionReelle | NFonctionComplexe | NSuiteRecurrenteReelle | NSuiteRecurrenteComplexe | NMesureCoefDir | NMesureProduitScalaire;
	static final public long NAutreCalcul = NSolutionEquation | NIntegrale | NTestExistence | NSommeIndicee | NProduitIndice | NPartieReelle
		| NPartieImaginaire | NModule | NArgument | NMesureLongueur | NMesureAngleNonOriente | NMesureAngleOriente
		| NMesureAbscisseSurDroite | NMesureAbscisseRepere | NMesureOrdonneeRepere | NMesureLongueurLigne | NMesureAirePolygone
		| NMesureCoefDir | NMesureProduitScalaire;
	static final public long NObjetCalculPourSourcesPrototype = NCalculReel | NCalculReelConstant | NCalculComplexe
		| NSuiteRecurrenteReelle | NSuiteRecurrenteComplexe | NVariable | NFonction | NFonctionComplexe | NRepere | NMesureCoefDir;
	static final public long NToutCalculNomme = NCalculReel |NCalculReelConstant | NCalculComplexe | NFonction | NFonctionComplexe
		| NDerivee | NSuiteRecurrenteReelle | NSuiteRecurrenteComplexe | NVariable | NSolutionEquation | NIntegrale
		| NTestExistence | NSommeIndicee | NProduitIndice | NPartieReelle | NPartieImaginaire | NModule | NArgument | NMesureCoefDir
		| NMesureLongueurLigne | NMesureAirePolygone | NMesureProduitScalaire;
	static final public long NToutCalculNommeSaufConst = NCalculReel | NCalculComplexe | NFonction | NFonctionComplexe
	| NDerivee | NSuiteRecurrenteReelle | NSuiteRecurrenteComplexe | NVariable | NSolutionEquation | NIntegrale
	| NTestExistence | NSommeIndicee | NProduitIndice | NPartieReelle | NPartieImaginaire | NModule | NArgument
	| NMesureLongueurLigne | NMesureAirePolygone | NMesureCoefDir | NMesureProduitScalaire;	
	static final public long NToutObjetNumeriquesSaufConst = NTouteValeurReelleSaufConst | NTouteValeurComplexe
		| NFonctionOuSuiteReelle | NFonctionOuSuiteComplexe | NRepere;
	static final public long NToutObjetNumerique = NTouteValeurReelle | NTouteValeurComplexe
		| NFonctionOuSuiteReelle | NFonctionOuSuiteComplexe | NRepere;
	static final public long NCalculOuFonctionNonConstante = NCalculReel | NCalculComplexe | NFonction | NFonctionComplexe;
	public final static long NObjetCalculSourcePourConst = NCalculReel | NCalculComplexe 	| NSuiteRecurrenteReelle
	| NSuiteRecurrenteComplexe | NVariable | NFonction | NFonctionComplexe; 
	public static final long NObjetFinalNumerique = NCalculReel | NCalculReelConstant | NSolutionEquation | NIntegrale
	| NTestExistence | NSommeIndicee |NProduitIndice | NPartieReelle | NPartieImaginaire | NModule | NArgument | NMesureLongueur
	| NMesureAngleNonOriente |NMesureAngleOriente | NMesureAbscisseSurDroite | NMesureAbscisseRepere | NMesureOrdonneeRepere
	| NMesureLongueurLigne | NMesureAirePolygone | NCalculComplexe | NMesureAffixe | NFonction | NFonctionComplexe | NDerivee
	| NMesureCoefDir | NRepere | NMesureProduitScalaire;
	
}
